﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using MySql;
using MySql.Data;
using MySql.Data.MySqlClient;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace FrontDesk
{
    public class clsFunction
    {

        public class Native
        {
            [DllImport("user32.dll", SetLastError = true)]
            private static extern uint SetParent(IntPtr hWndChild, IntPtr hWndNewParent);
            public static void LoadProcessInControl(string _Process, Control _Control)
            {
                System.Diagnostics.Process p = System.Diagnostics.Process.Start(_Process);
                p.WaitForInputIdle();
                Native.SetParent(p.MainWindowHandle, _Control.Handle);
            }

            [DllImport("user32.dll")]
            private static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);

            private const int SW_HIDE = 0;
            private const int SW_SHOWNORMAL = 1;
            private const int SW_SHOWMINIMIZED = 2;
            private const int SW_SHOWMAXIMIZED = 3;
            private const int SW_SHOWNOACTIVATE = 4;
            private const int SW_RESTORE = 9;
            private const int SW_SHOWDEFAULT = 10;
            private static bool ShowWindow(Process _Process, int nCmdShow)
            {
                return ShowWindowAsync(_Process.MainWindowHandle, nCmdShow);
            }
        }
        #region StringEmpty
		public static void isStringEmpty(string str)
		{
			MessageBox.Show(str + " is empty. Pls check the field.","Warning",MessageBoxButtons.OK,MessageBoxIcon.Warning);			
		}
		#endregion

        #region textboxEmpty
        public static void isTextEmpty(TextBox txt, string sLabel)
        {
            MessageBox.Show(sLabel + " is empty. Pls check the field.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            txt.Focus();
        }
        #endregion

        #region comboEmpty
        public static void isComboEmpty(ComboBox txt, string sLabel)
        {
            MessageBox.Show(sLabel + " is empty. Pls check the field.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            txt.Focus();
        }
        #endregion

        #region fillCombo
        public static void fillCombo(ComboBox cmb, string sSQL)
        {
            MySqlCommand Com = new MySqlCommand(sSQL,clsMySQL.con);
            MySqlDataReader reader = Com.ExecuteReader();
            cmb.Items.Clear();
            while (reader.Read())
            {
                cmb.Items.AddRange(new object[] { reader[0].ToString() });
            }
            reader.Close();
        }
        #endregion
        
        #region number
		public static void CharNum(string a, KeyPressEventArgs e)
		{
			if ( ( Keys )e.KeyChar <= Keys.Z && ( Keys )e.KeyChar >= Keys.A )
			{
				e.Handled = true;
			}
			else if ( ( Keys )e.KeyChar <= ( Keys ) 'z' && ( Keys )e.KeyChar >= ( Keys ) 'a' )
			{
				e.Handled = true;
			}
			else if( e.KeyChar == '~'||e.KeyChar == '!'||e.KeyChar == '@'||e.KeyChar == '#'||
				e.KeyChar == '$'||e.KeyChar == '%'||e.KeyChar == '^'||e.KeyChar == '&'||
				e.KeyChar == '*'||e.KeyChar == '('||e.KeyChar == ')'||e.KeyChar == '-'||e.KeyChar == '_'||
				e.KeyChar == '='||e.KeyChar == '+'||e.KeyChar == '|'||e.KeyChar =='\"'||e.KeyChar == ':'||
				e.KeyChar == '\\'||e.KeyChar == ';'||e.KeyChar == '"'||e.KeyChar == '\''||e.KeyChar == ','||
				e.KeyChar == '+'||e.KeyChar == '/'||e.KeyChar == '<'||e.KeyChar == '>'||e.KeyChar == '?')
			{
				e.Handled = true;

			}			
		}
		#endregion

        #region CheckPayCheck
        public static void CheckPayCheck(string sCheckNo, string sBankName, TextBox txBox)
        {
            MySqlCommand cmd = new MySqlCommand("Select * From Sales where PaymentType='Check' and Bank='" + sBankName + "' and CheckNo ='" + sCheckNo + "'",clsMySQL.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                MessageBox.Show("The Check No. that you have entered is already existed.", "Front Desk Module", MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
                txBox.Focus();
            }
        }
        #endregion

        #region AutoSettings
        public static void AutoSettings()
        { 
            
        }
        #endregion
        
        #region Currency
        #endregion

        #region Rental Plan
        public static void RentalPlan(string sCustomerNo)
        {
            MySqlCommand com = new MySqlCommand("Select * from qrycustomerplan where customers_id='" + sCustomerNo + "'",clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while(dr.Read())
            {
                clsVariables.maxhold =Convert.ToInt32(dr["MaxHold"].ToString());
                clsVariables.LateFee = Convert.ToInt32(dr["LateFeePerDay"].ToString());
                clsVariables.DefaultDays = Convert.ToInt32(dr["DefaultDays"].ToString());
            }
            dr.Close();
        }
        #endregion

        public clsFunction()
        {}
    }

   
}
