﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmAllCustomer : Form
    {
        public string SearchItem,RentalIDs;
        clsFunction clsFunc = new clsFunction();

        public frmAllCustomer()
        {
            InitializeComponent();
        }

        private void frmAllCustomer_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                this.Dispose();
            }
        }

        private void frmAllCustomer_Load(object sender, EventArgs e)
        {
            if (clsMySQL.con.State == ConnectionState.Open)
            { clsMySQL.con.Close(); }
            clsMySQL.con.Open();
            FillListView();            
        }
        
        public void AddCustomer()
        {
            frmCustomer customer = new frmCustomer();
            customer.mFormState = "ADD";
            customer.ShowDialog();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            AddCustomer();
        }

        private void cmdRefresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        public void FillListView()
        {
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            lvList.Items.Clear();

            cmd.CommandText = "SELECT * FROM Customers";
            cmd.Connection = clsMySQL.con;
            dr = cmd.ExecuteReader();

            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["customers_id"].ToString());
                             list.SubItems.Add(dr["FName"].ToString() +" "+ dr["LName"].ToString());
                             list.SubItems.Add(dr["PermanentAddress"].ToString());
                             list.SubItems.Add(dr["EmailAddress"].ToString());
                             list.SubItems.Add(dr["MobileNo"].ToString());
                             lvList.Items.AddRange(new ListViewItem[] { list });
                             list.ImageIndex = 1;
                             
            }
            dr.Close();
        }

        public void SearchQRY(string SearchItems)
        {
            MySqlCommand mysqlcommand = new MySqlCommand();
            MySqlDataReader reader;

            lvList.Items.Clear();
            mysqlcommand.CommandText = "Select customers.* From customers Where customers_id='" + SearchItems + "'";
            mysqlcommand.Connection = clsMySQL.con;
            mysqlcommand.CommandType = CommandType.Text;
            reader = mysqlcommand.ExecuteReader();

            while (reader.Read())
            {
                ListViewItem list = new ListViewItem(reader["customers_id"].ToString());
                list.SubItems.Add(reader["FName"].ToString() + " " + reader["MI"].ToString() + ". " + reader["LName"].ToString());
                list.SubItems.Add(reader["PermanentAddress"].ToString());
                list.SubItems.Add(reader["EmailAddress"].ToString());
                list.SubItems.Add(reader["MobileNo"].ToString());
                lvList.Items.AddRange(new ListViewItem[] { list });
            }
            reader.Close();
        }

        private void FillLastName()
       {
           MySqlCommand cmd = new MySqlCommand("Select * from customers where LName LIKE '%" + txtSearch.Text + "%'", clsMySQL.con);
           MySqlDataReader dr = cmd.ExecuteReader();
           lvList.Items.Clear();

           while (dr.Read())
           {
               ListViewItem list = new ListViewItem(dr["customers_id"].ToString());
               list.SubItems.Add(dr["FName"].ToString() + " " + dr["MI"].ToString() + ". " + dr["LName"].ToString());
               list.SubItems.Add(dr["PermanentAddress"].ToString());
               list.SubItems.Add(dr["EmailAddress"].ToString());
               list.SubItems.Add(dr["MobileNo"].ToString());
               lvList.Items.AddRange(new ListViewItem[] { list });
           }
           dr.Close();
       }
        
        public void DeleteQRY(string Items)
        {
            try
            {
                DialogResult msg = MessageBox.Show("Are you sure you want to remove this?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (msg == DialogResult.Yes)
                {
                    MySqlCommand cmds = new MySqlCommand();
                    cmds.CommandText = "DELETE FROM customers where customers_id='" + Items + "'";
                    cmds.Connection = clsMySQL.con;
                    cmds.ExecuteNonQuery();
                    MessageBox.Show("Record Successfully Deleted!!!", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }                
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message,"Front Desk Module",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
            }

        }



       public void ModifyCustomer()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlDataReader read;

            //try
            //{
                frmCustomer frm = null;
                foreach (Form f in this.MdiChildren)
                {
                    if (f is frmCustomer)
                    {
                        frm = (frmCustomer)f;
                        break;
                    }
                }
                if (frm == null)
                {
                    frm = new frmCustomer();
                    frm.mFormState = "EDIT";
                    //frm.MdiParent = MainForm.ActiveForm;
                }
                com.CommandText = "Select * from customers where customers_id='" + lvList.FocusedItem.Text + "'";
                com.Connection = clsMySQL.con;
                read = com.ExecuteReader();
                while (read.Read())
                {
                    frm.mFormState = "EDIT";

                    frm.txtCustomerNo.Text =read["customers_id"].ToString();
                    frm.txtFName.Text = read["FName"].ToString();
                    frm.txtLastName.Text = read["LName"].ToString();
                    frm.txtMI.Text = read["MI"].ToString();
                    frm.txtMobileNo.Text = read["MobileNo"].ToString();
                    frm.txtAddress.Text = read["PermanentAddress"].ToString();
                    frm.txtMailingAddress.Text = read["MailingAddress"].ToString();
                    frm.txtEmail.Text = read["EmailAddress"].ToString();
                    //frm.dtpDOB.Text = Convert.ToDateTime(read["DOB"].ToString());
                    frm.cboSex.Text = read["Gender"].ToString();
                    frm.txtUserName.Text = read["UserName"].ToString();
                    frm.txtPassword.Text = read["Password"].ToString();
                }
                read.Close();
                //com.Dispose();

                frm.Focus();
                frm.Show();
            //}
           // catch (Exception ex) { MessageBox.Show(ex.ToString()); }
        }

       private void modifyEntryToolStripMenuItem_Click(object sender, EventArgs e)
       {
           ModifyCustomer();
       }

       private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
       {
           DeleteQRY(lvList.FocusedItem.Text);
       }

       private void btn_Edit_Click(object sender, EventArgs e)
       {
           ModifyCustomer();
       }

       private void btn_close_Click(object sender, EventArgs e)
       {
           this.Dispose();
       }

       private void lvList_SelectedIndexChanged(object sender, EventArgs e)
       {
           ShowUnreturn(lvList.FocusedItem.Text);
           SearchItem = lvList.FocusedItem.Text;
       }
       void ShowUnreturn(string sID)
       {
               MySqlCommand cmd = new MySqlCommand("Select * From rentals where customers_id ='" + sID + "' and Status='" + "On" + "'", clsMySQL.con);
               MySqlDataReader dr = cmd.ExecuteReader();
               lvRented.Items.Clear();
               while (dr.Read())
               {
                   ListViewItem list = new ListViewItem(dr["Rental_ID"].ToString());
                   list.SubItems.Add(dr["products_id"].ToString());
                   list.SubItems.Add(dr["Description"].ToString());
                   list.SubItems.Add(dr["DatedRented"].ToString());
                   list.SubItems.Add(dr["DateDue"].ToString());
                   list.SubItems.Add(dr["Quantity"].ToString());
                   lvRented.Items.AddRange(new ListViewItem[] { list });
               }
               dr.Close();
       }

       private void returnItemsToolStripMenuItem_Click(object sender, EventArgs e)
       {
           frmReturn returns = new frmReturn();
           //returns.CustomerName = lvList.Items[lvList.FocusedItem.Index].SubItem;
           returns.ShowReturn(lvRented.FocusedItem.Text,lvList.FocusedItem.Text,"On");
       }

       private void lvRented_SelectedIndexChanged(object sender, EventArgs e)
       {
           RentalIDs = lvRented.FocusedItem.Text;
       }

       private void cmdSearch_Click(object sender, EventArgs e)
       {
           if (txtSearch.Text == "")
           {
               MessageBox.Show("Please enter item when searching...", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
           }
           else
           {
               switch (toolStripComboBox1.SelectedIndex)
               {
                   case 0:
                       FillLastName();
                       break;
                   case 1:
                       SearchQRY(txtSearch.Text);
                       break;
               }
           }
       }

       private void rentToolStripMenuItem_Click(object sender, EventArgs e)
       {
           frmRental rent = new frmRental();
           rent.txtSearch.Text = lvList.Items[lvList.FocusedItem.Index].SubItems[1].Text;
           rent.Show();

       }

       private void txtSearch_TextChanged(object sender, EventArgs e)
       {

       }

       private void txtSearch_KeyDown(object sender, KeyEventArgs e)
       {
           if (e.KeyCode == Keys.Enter)
           {
               cmdSearch_Click(this, new System.EventArgs());
           }
       }
       public void AutoCompleteLastname()
       {
           MySqlCommand Com = new MySqlCommand("Select * From customers", clsMySQL.con);
           MySqlDataReader reader = Com.ExecuteReader();
           txtSearch.Text = "";
           while (reader.Read())
           {
               txtSearch.AutoCompleteCustomSource.Add(reader["LName"].ToString());
           }
           reader.Close();
       }
       public void AutoCompleteCustomerNo()
       {
           MySqlCommand Com = new MySqlCommand("Select * From customers", clsMySQL.con);
           MySqlDataReader reader = Com.ExecuteReader();
           txtSearch.Text = "";
           while (reader.Read())
           {
               txtSearch.AutoCompleteCustomSource.Add(reader["customers_id"].ToString());
           }
           reader.Close();
       }

       private void toolStripComboBox1_SelectedIndexChanged(object sender, EventArgs e)
       {
           switch (toolStripComboBox1.Text)
           { 
               case "Lastname":
                   AutoCompleteLastname();
                   break;
               case "Customer No":
                   AutoCompleteCustomerNo();
                   break;
           }
       }

       private void txtSearch_Click(object sender, EventArgs e)
       {

       }

       private void emailToolStripMenuItem_Click(object sender, EventArgs e)
       {
           frmEmailLogin log = new frmEmailLogin();
           log.mFormState = "Custom Email";
           log.Show();
           clsVariables.ToEmail = lvList.Items[lvList.FocusedItem.Index].SubItems[3].Text;
           
       }

       
    }
}
