﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmCashSales : Form
    {
        int Invoice, StockOnHand;
        public string mFormState;

        bool blnSave;

        public bool blnPaid;

        public frmCashSales()
        {
            InitializeComponent();
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void frmCashSales_KeyDown(object sender, KeyEventArgs e)
        {
            int qty = 0;

            switch (e.KeyCode)
            { 
                case Keys.Escape:
                    blnSave = false;
                    this.Close();
                    break;
                case Keys.F1:
                    GenerateInvoice();
                    ResetEntry();
                    blnPaid = false;
                    break;

                case Keys.F2:
                       
                    break;
                case Keys.F4:
                    AddtoGrid();
                    break;
                case Keys.F5:
                    RemoveItem();
                    break;
                case Keys.F6:
                    if (Convert.ToInt32(txtQuantity.Text) < 1)
                    { lblStatus.Text = "Error while enter Quantity..."; txtQuantity.Text = "1"; }
                    else
                    {
                        qty = Convert.ToInt32(txtQuantity.Text);
                        qty = qty - 1;
                        txtQuantity.Text = qty.ToString();
                    }
                        break;
                case Keys.F7:
                        qty = Convert.ToInt32(txtQuantity.Text);
                         qty = qty + 1;
                         txtQuantity.Text = qty.ToString();
                        break;
            }
           
        }

        void RemoveItem()
        {
            if (dgView.SelectedRows.Count > 0)
            {
                dgView.Rows.RemoveAt(dgView.SelectedRows[0].Index);
                CalculateTotalPrice();
            }
            else
            {
                MessageBox.Show("Select one item to remove!");
            }        
        }
        private void GenerateInvoice()
        {
            MySqlCommand cmddr = new MySqlCommand("select NextNo from generator where TableName='" + "Cash_Sales "+ "'", clsMySQL.con);
            MySqlDataReader dr = cmddr.ExecuteReader();
            while (dr.Read())
            {
                string strid = dr["NextNo"].ToString();
                if (strid == "")
                {
                    this.txtInvoiceNo.Text = "Inv-" + "1";
                    Invoice = 1;
                }
                else
                {
                    Invoice = Convert.ToInt32(dr["NextNo"]) + 1;
                    txtInvoiceNo.Text = "Inv-" + Invoice.ToString();
                }
            }
            dr.Close();
            cmddr.Dispose();
        }

        void ResetEntry()
        {
        txtproductID.Text = "";
        txtDescription.Text = "";
        txtQuantity.Text = "1";
        txtUnitPrice.Text = "0.00";
        txtDisc.Text = "0";
        txtSubtotals.Text = "0.00";
        lblCashTender.Text = "0.00";
        txtGross.Text = "0.00";
        lblChange.Text = "0.00";
        lblStatus.Text = "";

        dgView.Rows.Clear();

        txtproductID.Focus();
        }

        private void frmCashSales_Load(object sender, EventArgs e)
        {
            if (clsMySQL.con.State == ConnectionState.Open)
            { clsMySQL.con.Close(); }
            clsMySQL.con.Open();
            ItemAutoComplete();
            AutoCompleteCustomer();

        }

        void ItemAutoComplete()
        {
            MySqlCommand com = new MySqlCommand("Select products_Title,products_id From products", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtDescription.AutoCompleteCustomSource.Add(dr["products_Title"].ToString());
                //txtproductID.AutoCompleteCustomSource.Add(dr["products_id"].ToString());
            }
            dr.Close();
        }

        void AutoCompleteCustomer()
        {
            MySqlCommand com = new MySqlCommand("Select Fullname, customers_id From qrycustomers_detail", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtCustomerNo.AutoCompleteCustomSource.Add(dr["Fullname"].ToString());
            }
            dr.Close();
        }


        void SearchItem(string ItemNo)
        {
            double UnitPrice;

            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            cmd.CommandText = "Select * From products where products_Title Like '%" + ItemNo + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                txtDescription.Text = (String)dr["products_Title"].ToString();
                UnitPrice = System.Double.Parse(dr["SellingPrice"].ToString());
                txtUnitPrice.Text = String.Format("{0:0.##}", UnitPrice);
                txtStockID.Text = dr["products_id"].ToString();
                txtproductID.Text = txtStockID.Text;
            }
            dr.Close();
        }

        void AddtoGrid()
        {
            if (txtproductID.Text == "" || txtDescription.Text == "")
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (StockOnHand < Convert.ToInt32(txtQuantity.Text))
            {
                MessageBox.Show("Sorry item is out of stock.\n Please select other item..");
                txtproductID.Focus();
            }
            else if (StockOnHand <= 0)
            {
                MessageBox.Show("Sorry item is out of stock.\n Please select other item..");
                txtproductID.Focus();
            }
            else
            {
                for (int row = 0; row < dgView.Rows.Count; row++)
                {
                    for (int col = 0; col < dgView.Columns.Count; col++)
                    {
                        if (dgView.Rows[row].Cells[col].Value != null &&
                          dgView.Rows[row].Cells[col].Value.Equals(txtDescription.Text))
                        {
                            MessageBox.Show("Item Already Exist...");
                            return;
                        }
                    }
                }

                int n = dgView.Rows.Add();
                //int intQtyOrdered = int.Parse(txtQty.Text);

                dgView.Rows[n].Cells[0].Value = txtStockID.Text;
                dgView.Rows[n].Cells[1].Value = txtDescription.Text;
                dgView.Rows[n].Cells[2].Value = txtQuantity.Text;
                dgView.Rows[n].Cells[3].Value = txtUnitPrice.Text;
                dgView.Rows[n].Cells[4].Value = txtGross.Text;
                dgView.Rows[n].Cells[5].Value = txtDisc.Text;
                dgView.Rows[n].Cells[6].Value = txtSubtotals.Text;
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;

                txtproductID.Text = "";
                txtDescription.Text = "";
                txtQuantity.Text = "";
                txtUnitPrice.Text = "";
                txtSubtotals.Text = "";
                txtDisc.Text = "";
                txtGross.Text = "";

                CalculateTotalPrice();
            }
        }

        void CalculateTotalPrice()
        {
            //Initial Amount
            decimal total_amount = 0;
            decimal total_cramount = 0;
            decimal tAX = 0;
            decimal tVat = 0;
            //Quantity
            int Quan = 0;
            int Quant = 0;
            int Quanti = 0;
            string ans;
            //Discount
            decimal cDAmount = 0;
            decimal price = 0;

            int i = dgView.RowCount;

            for (int a = 0; a < i; a++)
            {
                try
                {
                    //Initial Total of items in list
                    total_amount += decimal.Parse(dgView.Rows[a].Cells[4].Value.ToString());
                    total_cramount += decimal.Parse(dgView.Rows[a].Cells[6].Value.ToString());
                    //Total Quantity of items in list
                    Quan += int.Parse(dgView.Rows[a].Cells[2].Value.ToString());
                    //Total Price
                    price += decimal.Parse(dgView.Rows[a].Cells[3].Value.ToString());
                    //Total Discount of items in list
                    cDAmount = cDAmount + Convert.ToDecimal((Convert.ToDecimal(dgView.Rows[a].Cells[5].Value.ToString()) / 100) * (Convert.ToDecimal(Quan) * Convert.ToDecimal(price)));
                }
                catch (Exception)
                {
                }
            }
            Quanti = Quant + Quan;
            tAX = (total_cramount / 1.12m);
            tVat = total_cramount - Convert.ToDecimal(tAX);

            ans = Quanti.ToString();

            lblDiscount.Text = cDAmount.ToString();

            lblTotal.Text = String.Format("{0:0.00}", total_amount);
            lblTot.Text = String.Format("{0:0.00}", total_cramount);
            lblTaxbase.Text = String.Format("{0:0.##}", tAX);
            lblVAT12.Text = String.Format("{0:0.00}", tVat);
        }

        void StockChecker(string sProductId)
        {
            MySqlCommand check = new MySqlCommand("Select * from StockInv where products_id ='" + sProductId + "'", clsMySQL.con);
            MySqlDataReader dr = check.ExecuteReader();
            while (dr.Read())
            {
                StockOnHand = Convert.ToInt32(dr["EndingInv"].ToString());
            }
            dr.Close();
        }

        private void txtQuantity_TextChanged(object sender, EventArgs e)
        {
            decimal Total;
            decimal sum = 0;

            if (txtQuantity.Text.Equals("") || txtDisc.Text.Equals(""))
            {
                txtSubtotals.Text = "0.00";
            }
            else
            {
                try
                {
                    int quantity = int.Parse(txtQuantity.Text);
                    decimal unitprice = Convert.ToDecimal(txtUnitPrice.Text);
                    decimal discount = decimal.Parse(txtDisc.Text);


                    Total = decimal.Parse(txtUnitPrice.Text) * decimal.Parse(txtQuantity.Text);
                    txtGross.Text = String.Format("{0:0.##}", Total);

                    sum = Convert.ToDecimal(Total - ((discount / 100) * Total));
                    txtSubtotals.Text = sum.ToString();
                }
                catch
                { }

            }
        }

        private void txtproductID_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Tab)
            {
                SearchItem(txtproductID.Text);
                StockChecker(txtStockID.Text);

                txtQuantity.Text = "1";
                txtDisc.Text = "0";
                lblCashTender.Text = "0.00";
            }
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (txtInvoiceNo.Text == "")
            {
                MessageBox.Show("Please enter Cash Slip.");
            }
            else if (blnPaid == false)
            {
                lblStatus.Text = "Transaction not yet paid.";
            }
            else if (dgView.RowCount < 1)
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.", "Cash Sales", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtproductID.Focus();
            }
            else
            {
                SaveRecord();
            }
        }

        public void SaveRecord()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string Qty = string.Empty;
            string Amount = string.Empty;
            string Discount = string.Empty;

            DateTime d1 = DateTime.Now;

            string sRemark = "Payment for Sales Invoice with Ref # " + txtInvoiceNo.Text.Trim();

            MySqlCommand Cash_Sales = new MySqlCommand();
            MySqlCommand Inv = new MySqlCommand();
            MySqlCommand Cash_Details = new MySqlCommand();


            Cash_Sales.CommandText = "Insert Into cash_sales(CashSalesID,DateAdded,CreatedBy,InvoiceNo,Date,SoldTo,Gross,Discount,TaxBase,Vat,NetAmount,Tender,Changed,Remarks) " +
                                    "Values ('" + Invoice + "','" + DateTime.Now.Date.ToShortDateString() + "','" + clsVariables.fullname + "','" + txtInvoiceNo.Text + "','" + DateTime.Now.Date.ToShortDateString() + "','" + txtCustomerNo.Text + "','" + lblTotal.Text + "','" + lblDiscount.Text + "','" + lblTaxbase.Text + "','" + lblVAT12.Text + "','" + lblTot.Text + "','" + lblCashTender.Text + "','" + lblChange.Text + "','" + sRemark + "')";
            Cash_Sales.Connection = clsMySQL.con;
            Cash_Sales.ExecuteNonQuery();

            MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + Invoice + "' where TableName ='" + "Sales_Order" + "'", clsMySQL.con);
            pipz.ExecuteNonQuery();


            for (int i = 0; i < dgView.RowCount; i++)
            {

                ItemNo = dgView.Rows[i].Cells[0].Value.ToString();
                Description = dgView.Rows[i].Cells[1].Value.ToString();
                UnitPrice = dgView.Rows[i].Cells[3].Value.ToString();
                Qty = dgView.Rows[i].Cells[2].Value.ToString();
                Amount = dgView.Rows[i].Cells[4].Value.ToString();
                Discount = dgView.Rows[i].Cells[5].Value.ToString();

                DateTime d2 = d1.AddDays(clsVariables.DefaultDays);

                Cash_Details.CommandText = "Insert Into cash_sales_details(CashSalesID,products_Title,Qty,Price,Discount) Values ('" + Invoice + "','" + Description + "','" + Qty + "','" + UnitPrice + "','" + Discount + "')";
                Cash_Details.Connection = clsMySQL.con;
                Cash_Details.ExecuteNonQuery();

                Inv.CommandText = "Update stockinv set EndingInv = EndingInv - " + Qty + ", InvUpdateDate ='" + DateTime.Now.ToShortDateString() + "' where products_id = '" + ItemNo + "'";
                Inv.Connection = clsMySQL.con;
                Inv.ExecuteNonQuery();

                MySqlCommand pip = new MySqlCommand("Update Generator Set NextNo='" + Invoice + "' where TableName ='" + "Cash_Sales" + "'", clsMySQL.con);
                pip.ExecuteNonQuery();
            }
            lblStatus.Text = "Changes in record has been successfully saved.";
            PrintInvoice(txtInvoiceNo.Text);
        }


        void PrintInvoice(string InvoiceNo)
        {
            frmPrintPreview print = new frmPrintPreview();
            print.WindowState = FormWindowState.Maximized;
            print.strReport = "Receipt";
            print.strWhere = "{Cash_Sales.InvoiceNo} ='" + InvoiceNo + "'";
            print.Show();
        }


        private void lblCashTender_TextChanged(object sender, EventArgs e)
        {
            if (lblCashTender.Text == "")
            {
                lblChange.Text = "0.00";
                blnPaid = false;
            }
            else
            {
                decimal subTotal = (decimal.Parse(lblCashTender.Text) - decimal.Parse(lblTot.Text));
                lblChange.Text = String.Format("{0:0.##}", subTotal);
                blnPaid = true;
            }
        }

        private void txtDescription_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Tab)
            {
                SearchItem(txtDescription.Text);
                StockChecker(txtStockID.Text);

                txtQuantity.Text = "1";
                txtDisc.Text = "0";
                lblCashTender.Text = "0.00";
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (blnSave == false)
            {
                lblStatus.Text = "Settle a transaction first before printing a receipt.";
            }
            PrintInvoice(txtInvoiceNo.Text);
        }

    }
}
