﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmCustPayEntry : Form
    {
        public string mFormState;
        public double mAmountDue;
        public string sDescription;

        public bool mShowAdd;
        public bool mShowEdit;

        public int myID;

        public frmCustPayEntry()
        {
            InitializeComponent();
        }

        private void frmCustPayEntry_Load(object sender, EventArgs e)
        {
            if (clsMySQL.con.State == ConnectionState.Open)
            { clsMySQL.con.Close(); }
            clsMySQL.con.Open();
        }

        public void ShowAdd(DateTime dCustPayDate,string CustPayID,string lCustID,double dAmount,
                             double dAmountDue,string sRemarks)
        {
            mFormState = "ADD";
            if (dCustPayDate.Equals(0))
            { clsVariables.CustPayDate = DateTime.Now; }
            else
            { 
                clsVariables.CustPayDate = dCustPayDate; 
                dtpCustPayDate.Enabled =false;
            } 
            
            clsVariables.Amount =dAmount;
            clsVariables.Remarks = sRemarks;
            clsVariables.FK_CustID = lCustID;
            clsVariables.CustPayID = CustPayID;
            clsVariables.sDateRented = dtpCustPayDate.Value.Date;
            clsVariables.sTotalAmount = dAmount;

            ShowCustomerInfo(lCustID);

            mAmountDue = dAmountDue;

            this.ShowDialog();

            return;
        }

        public void ShowEdit(string lCustPayID)
        {
            mFormState = "EDIT";
            clsVariables.CustPayID = lCustPayID;

            this.ShowDialog();
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            switch (mFormState)
            {
                case "ADD":
                    //SaveAdd();
                    this.Close();
                    break;
                case "EDIT":

                        break;
            }
        }
        void ShowCustomerInfo(string CustPayIDs)
        {
            MySqlCommand cmd = new MySqlCommand("Select FName, MI, LName From customers where customers_id='" + CustPayIDs + "'", clsMySQL.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            while(dr.Read())
            {
                txtCustomer.Text = dr["LName"].ToString() + ", " + dr["FName"].ToString() + " " + dr["MI"].ToString() + ".";
            }
            dr.Close();
        }

        private void frmCustPayEntry_Activated(object sender, EventArgs e)
        {
           switch (mFormState)
           {
               case "ADD":
                    this.Text = "Add Payment Entry";
                    txtCustPayID.Text = Convert.ToString(clsVariables.CustPayID);
                    dtpCustPayDate.Value = clsVariables.CustPayDate;
                    dtpDateIssued.Value = clsVariables.CustPayDate;
                    dtpDateDue.Value = clsVariables.CustPayDate;

                    txtAmount.Text = Convert.ToString(String.Format("{0:0.##}",clsVariables.Amount));
                    txtRemarks.Text = clsVariables.Remarks;
                    break;
               case "EDIT":
                    this.Text = "Add Payment Entry";
                    dtpCustPayDate.Value = clsVariables.CustPayDate;

                    if (clsVariables.FP == "Check")
                    {
                        txtCheckNo.Text = clsVariables.CheckNo;
                        txtAccountNo.Text = clsVariables.AccountNo;
                        dtpDateIssued.Value = clsVariables.DateIssued;
                        dtpDateDue.Value = clsVariables.DateDue;
                        txtAccountName.Text = clsVariables.AccountName;
                        cboBank.Text = clsVariables.BankName;
                    }
                    else if(clsVariables.FP == "Cash")
                    {
                        txtOtherFP.Text = clsVariables.FP;
                    }
                    txtAmount.Text = Convert.ToString(String.Format("{0:0.##}", clsVariables.Amount));
                    txtRemarks.Text = clsVariables.Remarks;
                break;
            }
        }

        private void cmbFP_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch(cmbFP.SelectedIndex)
            {
                case 0:
                    Form_ShowCheck(false);
                    txtOtherFP.Visible = false;
                    lblOtherFP.Visible = false;
                    break;
                case 1:
                    Form_ShowCheck(true);
                    txtOtherFP.Visible = false;
                    lblOtherFP.Visible = false;
                    break;
                 case 2:
                    Form_ShowCheck(false);
                    txtOtherFP.Visible = true;
                    lblOtherFP.Visible = true;
                    break;
            }
        }

        void Form_ShowCheck(bool newValue)
        {
            txtCheckNo.Enabled = newValue;
            txtAccountNo.Enabled = newValue;
            dtpDateIssued.Enabled = newValue;
            dtpDateDue.Enabled = newValue;
            txtAccountName.Enabled = newValue;
            cboBank.Enabled = newValue;
            groupBox2.Enabled = newValue;
        }

        private void cboBank_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        void SaveAdd()
        {
            MySqlCommand cmd = new MySqlCommand();
            MySqlCommand com = new MySqlCommand();

            if (System.Int32.Parse(txtAmount.Text) > 0)
            {
                MessageBox.Show("Please enter valid amount");
                txtAmount.Focus();
            }

            if (mAmountDue > 0)
            {
                if (System.Int32.Parse(txtAmount.Text) > mAmountDue)
                {
                    MessageBox.Show("Please enter valid amount. It mus be less than or equal to " + mAmountDue.ToString() + ".");

                }
            }

            switch (cmbFP.SelectedIndex)
            { 
                case 0:
                    clsVariables.FP = "Cash";
                    clsVariables.Cleared = true;
                    break; 
                case 1:
                    if (txtCheckNo.Text == "")
                    { clsFunction.isTextEmpty(txtCheckNo,"Please enter CHECK NO."); }
                    if (txtAccountNo.Text == "")
                    { clsFunction.isTextEmpty(txtAccountNo, "Please enter ACCOUNT NO.");}
                    if (cboBank.Text == "")
                    { clsFunction.isComboEmpty(cboBank,"Please enter BANK NAME");}

                    if(clsVariables.CheckNo.Trim() != (txtCheckNo.Text.Trim()))
                    {
                        clsFunction.CheckPayCheck(txtCheckNo.Text,cboBank.Text,txtCheckNo);
                        clsVariables.FP = "Check";
                        clsVariables.AccountName = txtAccountName.Text;
                        clsVariables.CheckNo = txtCheckNo.Text;
                        clsVariables.DateIssued = dtpDateIssued.Value;
                        clsVariables.DateDue = dtpDateDue.Value;
                        clsVariables.BankName = cboBank.Text;
                    }
                    break;
                case 2:
                    if (txtOtherFP.Text== "")
                    { clsFunction.isTextEmpty(txtOtherFP, "Please enter other Form of Payment."); }
                    if (txtOtherFP.Text == "Check" || txtOtherFP.Text == "Cash")
                    { MessageBox.Show("Other Form of Payment must not be be 'Check' or 'Cash'"); txtOtherFP.Focus(); }
                    clsVariables.FP = txtOtherFP.Text;
                    clsVariables.Cleared = true;
                    break;
            }

            clsVariables.CustPayDate = dtpCustPayDate.Value;
            clsVariables.Amount = System.Int32.Parse(txtAmount.Text);
            clsVariables.Remarks = txtRemarks.Text;
            clsVariables.RM = DateTime.Now;

            cmd.CommandText = "Insert Into Sales(n_id,Rental_ID,products_id,Description,customers_id,DateRented,DateDue,DateReturn,Status,RentPrice,TotalAmount,Quantity)" +
                                "Values ('" + myID + "','" + clsVariables.RentalItemID + "','" + clsVariables.RentalItems + "','" + clsVariables.FK_CustID +
                                "','" + clsVariables.sDateRented + dtpCustPayDate.Value.Date + "','" + dtpCustPayDate.Value.Date + "','" + "Unreturned" + "','" + clsVariables.sRentPrice + "','" + clsVariables.sTotalAmount + "','" + clsVariables.sQuantity + "')";
            cmd.Connection = clsMySQL.con;
            cmd.ExecuteNonQuery();

            frmRental r = new frmRental();
            r.SaveRentals();
            MessageBox.Show("Record Successully Saved");
            this.Close();
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            switch (mFormState)
            { 
                case "ADD":
                    mShowAdd = false;
                    break;
                case"EDIT":
                    mShowEdit = false;
                    break;
            }
            this.Close();
        }

    }
}
