﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;
using System.Globalization;

namespace FrontDesk
{
    public partial class frmCustomer : Form
    {
        MySqlCommand cmd = new MySqlCommand();
        object RentalPlanID;
        int myID;

        public string mFormState;

        public frmCustomer()
        {
            InitializeComponent();
        }

        private void cmdOK_Click(object sender, EventArgs e)
        {
            switch (mFormState)
            {
                case "ADD":
                    SaveQRY();
                    break;
                case "EDIT":
                    UpdateQRY(txtCustomerNo.Text);
                    break;
            }
            
            this.Close();
        }

        void UpdateQRY(string sCustomerID)
        {
            MySqlCommand cmd = new MySqlCommand();
            cmd.CommandText = "Update customers Set customers_id='" + sCustomerID + "',FName='" + txtFName.Text + "', MI='" + txtMI.Text + "', LName='" + txtLastName.Text + "',Gender='" + cboGender.Text + 
                              "',DOB='" + dtpDOB.Value.Date + "',EmailAddress='"+ txtEmail.Text + "',PermanentAddress='" + txtAddress.Text + "',MailingAddress='" + txtMailingAddress.Text + "',MobileNo='" + txtMobileNo.Text + 
                              "', RentalCategory_Name='" + cboRentalPlan.Text + "',UserName='" + txtUserName.Text + "', Password='" + txtPassword.Text + "' where customers_id='" + sCustomerID + "'";
            cmd.Connection = clsMySQL.con;
            cmd.ExecuteNonQuery();

            MessageBox.Show("Record Successfully Updated!", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
            this.Close();        
        }

        void SaveQRY()
        {
            if (txtFName.Text == "" || txtLastName.Text == "" || txtMobileNo.Text == "" || txtEmail.Text == "")
            {
                MessageBox.Show("Fill up all the required fields", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                txtFName.Focus();
            }
            else
            {
                CheckExistingRecord();
            }

        }

        void CheckExistingRecord()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlDataReader reader;
            try
            {
                com.CommandText = "Select * from customers where customers_id='" + txtCustomerNo.Text + "'";
                com.Connection = clsMySQL.con;

                reader = com.ExecuteReader();
                reader.Read();

                if (reader.HasRows)
                {
                    MessageBox.Show("Customer is already existed", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    txtFName.Focus();
                }
                else
                {
                    reader.Close();
                    com.CommandText = "Insert Into customers(customers_id,FName,MI,LName,Gender,DOB,PermanentAddress,MailingAddress,MobileNo,EmailAddress,UserName,Password,RentalCategory_Name,n_id) Values('" + txtCustomerNo.Text.Trim().ToUpper() + "','" + txtFName.Text + "','" + txtMI.Text + "','" + txtLastName.Text +
                                        "','" + cboSex.Text + "','" + dtpDOB.Value.Date + "','" + txtAddress.Text + "','" + txtMailingAddress.Text + "','" + txtMobileNo.Text + "','" + txtEmail.Text + "','" + txtUserName.Text + "','" + txtPassword.Text + "','" + cboRentalPlan.Text + "','" + myID + "')";
                    com.Connection = clsMySQL.con;
                    com.ExecuteNonQuery();

                    MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Sales_Order" + "'", clsMySQL.con);
                    pipz.ExecuteNonQuery();


                    MessageBox.Show("Record Successfully Saved!", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    
                    frmAllCustomer cust = new frmAllCustomer();
                    cust.FillListView();
                   
                }
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message,"Front Desk Module",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
            }

        }

        
        private void GenerateID()
        {
                try
                {
                    MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator where TableName='" +"Customer" + "'", clsMySQL.con);
                    MySqlDataReader dr = cmddr.ExecuteReader();

                    while (dr.Read())
                    {
                        string strid = dr["ids"].ToString();
                        if (strid == "")
                        {
                            this.txtCustomerNo.Text = "CUST-" + "1";
                            myID = 1;
                        }
                        else
                        {
                            myID = Convert.ToInt32(dr["ids"]) + 1;
                           txtCustomerNo.Text = "CUST-" + myID.ToString();
                        }

                    }
                    dr.Close();
                    cmddr.Dispose();
                }
                catch (Exception exp)
                {
                   MessageBox.Show(exp.Message);
                }
            }

        
        private void frmCustomer_Load(object sender, EventArgs e)
        {
            switch (mFormState)
            { 
                case "ADD":
                    GenerateID();
                    clsFunction.fillCombo(cboRentalPlan, "Select RentalCategory_Name From rentalcategory");
                    CurrentRentCount(txtCustomerNo.Text);
                    break;
                case "EDIT":
                    clsFunction.fillCombo(cboRentalPlan, "Select RentalCategory_Name From rentalcategory");
                    CurrentRentCount(txtCustomerNo.Text);
                    break;
            }
        }
        void CurrentRentCount(string sID)
        {
            MySqlCommand cmd = new MySqlCommand("Select Count(customers_id) as ids From rentals where customers_id='"+ sID + "'", clsMySQL.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            if (dr.Read())
            {
                lblCurrentRentals.Text = dr["ids"].ToString();
            }
            dr.Close();
        }

        private void cmdRent_Click(object sender, EventArgs e)
        {
            this.Dispose();
            frmRental rent = new frmRental();
            rent.ShowDialog();
        }

        private void cmdViewRentals_Click(object sender, EventArgs e)
        {
            frmCurrentRentals rentals = new frmCurrentRentals();
            rentals.ShowRentals(txtCustomerNo.Text);
        }

     }
}

