﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmRental : Form
    {

        int myID, Invoice,intQtyOrdered;
        decimal subTotal;
        string mFormState;

        int StockOnHand, StockOut;

        public frmRental()
        {
            InitializeComponent();
        }

        private void GenerateInvoice()
        {
                MySqlCommand cmddr = new MySqlCommand("select NextNo from generator where TableName='" +"Cash_Sales"+ "'", clsMySQL.con);
                MySqlDataReader dr = cmddr.ExecuteReader();
                while (dr.Read())
                {
                    string strid = (dr["NextNo"].ToString());
                    if (strid == "")
                    {
                        this.txtRentalID.Text = "Inv-" + "1";
                        Invoice = 1; 
                    }
                    else
                    {
                        Invoice = Convert.ToInt32(dr["NextNo"]) + 1;
                        txtInvoiceNo.Text = "Inv-" + Invoice.ToString();
                    }
                }
                dr.Close();
                cmddr.Dispose();
        }

        private void GenerateID()
        {
                MySqlCommand cmddr = new MySqlCommand("select NextNo from generator where TableName='" + "Rental" + "'", clsMySQL.con);
                MySqlDataReader dr = cmddr.ExecuteReader();
                while (dr.Read())
                {
                    string strid = dr["NextNo"].ToString();
                    if (strid =="")
                    {
                        this.txtInvoiceNo.Text = "RENT-" + "1";
                        myID = 1; ;
                    }
                    else
                    {
                        myID = Convert.ToInt32(dr["NextNo"]) + 1;
                        txtRentalID.Text= "RENT-" + myID.ToString();
                    }
                }
                dr.Close();
                cmddr.Dispose();
        }


        private void frmRent_Load(object sender, EventArgs e)
        {
            if (clsMySQL.con.State == ConnectionState.Open)
            { clsMySQL.con.Close(); }
            clsMySQL.con.Open();

            mFormState = "ADD";
            GenerateID();
            GenerateInvoice();

            FillCustomer();
            AutoCompleteSourceItemNo();
            AutoCompleteSourceItem();
        }

        void AutoCompleteSourceItemNo()
        {
            MySqlCommand Com = new MySqlCommand("Select * From products", clsMySQL.con);
            MySqlDataReader reader = Com.ExecuteReader();
            txtSearch.Text = "";
            while (reader.Read())
            {
                txtproductID.AutoCompleteCustomSource.Add(reader["products_id"].ToString());
                txtDescription.AutoCompleteCustomSource.Add(reader["products_Title"].ToString());
            }
                reader.Close();
        }

        void AutoCompleteSourceItem()
        {
            MySqlCommand Com = new MySqlCommand("Select * From products", clsMySQL.con);
            MySqlDataReader reader = Com.ExecuteReader();
            txtSearch.Text = "";
            while (reader.Read())
            {
                txtproductID.AutoCompleteCustomSource.Add(reader["products_id"].ToString());
            }
            reader.Close();
        }


        void CurrentRentCount(string sID)
        {
            MySqlCommand cmd = new MySqlCommand("Select Count(customers_id) as ids From rentals where customers_id='" + sID + "' and Status='" + "On" + "'", clsMySQL.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            if (dr.Read())
            {
                lblCurrentRentals.Text = dr["ids"].ToString();
            }
            dr.Close();
        }

        void FillCustomer()
        {
            MySqlDataReader reader;
            MySqlCommand sSQL = new MySqlCommand();

            sSQL.CommandText = "SELECT CONCAT( LName,', ', FName,  ' ', MI, '.' ) AS Fullname,customers_id FROM customers";
            sSQL.Connection = clsMySQL.con;
            reader = sSQL.ExecuteReader();
            txtSearch.Items.Clear();
            while (reader.Read())
            {
                txtSearch.Items.AddRange(new object[] { (String)reader["Fullname"].ToString() });
                txtSearch.AutoCompleteCustomSource.Add((String)reader["Fullname"].ToString());
            }
            reader.Close();
        }
        
        void SearchItem(string ItemNo)
        {
            double UnitPrice;

            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            cmd.CommandText = "Select * From products where products_id ='" + ItemNo + "'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                txtDescription.Text = (String)dr["products_Title"].ToString();
                UnitPrice = System.Double.Parse(dr["SellingPrice"].ToString());
                txtUnitPrice.Text = String.Format("{0:0.##}",UnitPrice); 
            }
            dr.Close();
        }

        void SearchItemTitle(string ItemNo)
        {
            double UnitPrice;

            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            cmd.CommandText = "Select * From products where products_Title Like '%" + ItemNo + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                txtproductID.Text = (String)dr["products_id"].ToString();
                UnitPrice = System.Double.Parse(dr["SellingPrice"].ToString());
                txtUnitPrice.Text = String.Format("{0:0.##}", UnitPrice);
            }
            dr.Close();
        }

        private void txtQuantity_TextChanged(object sender, EventArgs e)
        {
            decimal Total;
            decimal sum = 0;

            if (txtQuantity.Text.Equals("") || txtDisc.Text.Equals(""))
            {
                txtSubtotals.Text = "0.00";
            }
            else
            {
                try
                {
                    int quantity = int.Parse(txtQuantity.Text);
                    decimal unitprice = decimal.Parse(txtUnitPrice.Text);
                    decimal discount = decimal.Parse(txtDisc.Text);


                    Total = decimal.Parse(txtUnitPrice.Text) * decimal.Parse(txtQuantity.Text);
                    txtGross.Text = String.Format("{0:0.##}", Total);

                    sum = Convert.ToDecimal(Total - ((discount / 100) * Total));
                    txtSubtotals.Text = sum.ToString();
                }
                catch
                { }
            }
        }

        private void cmdADD_Click(object sender, EventArgs e)
        {
            if (txtproductID.Text == "" || txtDescription.Text == "")
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            if (StockOnHand < Convert.ToInt32(txtQuantity.Text))
            {
                MessageBox.Show("Sorry item is out of stock.\n Please select other item..");
                txtproductID.Focus();
            }
            else if(StockOnHand <= 0)
            {
                MessageBox.Show("Sorry item is out of stock.\n Please select other item..");
                txtproductID.Focus();
            }
            else
            {
                for (int row = 0; row < dgView.Rows.Count; row++)
                {
                    for (int col = 0; col < dgView.Columns.Count; col++)
                    {
                        if (dgView.Rows[row].Cells[col].Value != null &&
                          dgView.Rows[row].Cells[col].Value.Equals(txtDescription.Text))
                        {
                            MessageBox.Show("Item Already Exist...");
                            return;
                        }
                    }
                }

                intQtyOrdered = Convert.ToInt32(txtQuantity.Text);

                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = txtproductID.Text;
                dgView.Rows[n].Cells[1].Value = txtDescription.Text;
                dgView.Rows[n].Cells[2].Value = intQtyOrdered;
                dgView.Rows[n].Cells[3].Value = txtUnitPrice.Text;
                dgView.Rows[n].Cells[4].Value = txtGross.Text;
                dgView.Rows[n].Cells[5].Value= txtDisc.Text;
                dgView.Rows[n].Cells[6].Value = txtSubtotals.Text;
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;

                txtproductID.Text = "";
                txtDescription.Text = "";
                txtQuantity.Text = "";
                txtUnitPrice.Text = "";
                txtSubtotals.Text = "";
                txtDisc.Text = "";
                txtGross.Text = "";
                

                CalculateTotalPrice();

            }
        }

        void CalculateTotalPrice()
        {
            //Initial Amount
            decimal total_amount =0;
            decimal total_cramount =0;
            decimal tAX=0;
            decimal tVat =0 ;
            //Quantity
            int Quan = 0;
            int Quant = 0;
            int Quanti = 0;
            //Discount
            decimal cDAmount = 0;
            decimal price = 0;

            int i = dgView.RowCount;

            for (int a = 0; a < i; a++)
            {
                try
                {
                    //Initial Total of items in list
                    total_amount += decimal.Parse(dgView.Rows[a].Cells[4].Value.ToString());
                    total_cramount += decimal.Parse(dgView.Rows[a].Cells[6].Value.ToString());
                    //Total Quantity of items in list
                    Quan += int.Parse(dgView.Rows[a].Cells[2].Value.ToString());
                    //Total Price
                    price += decimal.Parse(dgView.Rows[a].Cells[3].Value.ToString());
                    //Total Discount of items in list
                    cDAmount = cDAmount + Convert.ToDecimal((Convert.ToDecimal(dgView.Rows[a].Cells[5].Value.ToString()) / 100) * (Convert.ToDecimal(Quan) * Convert.ToDecimal(price)));
                }
                catch (Exception)
                {
                }
             }
            Quanti = Quant + Quan;

            tAX = total_cramount / (1.12m);
            tVat = total_cramount - Convert.ToDecimal(tAX);

            lblQuantity.Text = Quanti.ToString();

            txtDiscount.Text = cDAmount.ToString();

            txtSubTotal.Text = String.Format("{0:0.##}", total_amount);
            txtTotal.Text = String.Format("{0:0.##}", total_cramount);
            txtTax.Text = String.Format("{0:0.##}", tAX);
            txtVat.Text = String.Format("{0:0.##}", tVat);
     }

       public void ShowRentals(string ID)
        {
            MySqlCommand com = new MySqlCommand();
            MySqlDataReader read;
            com.CommandText = "SELECT * FROM qrycustomers_detail where Fullname ='" + ID + "'";
            com.Connection = clsMySQL.con;
            read = com.ExecuteReader();
            while (read.Read())
            {
                lblCustomerID.Text = read["customers_id"].ToString();
                lblName.Text = read["FullName"].ToString();
                lblEmailAddress.Text = read["EmailAddress"].ToString();
                lblAddress.Text = read["PermanentAddress"].ToString();
            }
            read.Close();
        }

        private void txtSearch_SelectedIndexChanged(object sender, EventArgs e)
        {
            ShowRentals(txtSearch.Text);
            CurrentRentCount(lblCustomerID.Text);
            clsFunction.RentalPlan(lblCustomerID.Text);
            lblMaxHold.Text = clsVariables.maxhold.ToString();
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            switch (mFormState)
            {
                case "ADD":
                    SaveAdd();
                    break;
                case "EDIT":
                    break;
            }
        }

        void SaveAdd()
        { 
            string lCustPayID;
            decimal dNewAmount;
            
            lCustPayID =lblCustomerID.Text;
            dNewAmount =decimal.Parse(txtTotal.Text);

            if (dgView.RowCount < 1)
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (int.Parse(lblCurrentRentals.Text) > 0)
            {
                MessageBox.Show("Unable to rent. Return the rented items first...");
            }
            else if (txtSearch.Text == "")
            {
                MessageBox.Show("Please select Customer before you can save this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (Convert.ToInt32(lblQuantity.Text) > Convert.ToInt32(lblMaxHold.Text))
            {
                MessageBox.Show("Customer reach its maximum rental limit. Customer allow only " + lblMaxHold.Text + " rental/rentals.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (txtCash.Text == "" || txtCash.Text == "0.00")
            {
                MessageBox.Show("Please pay the transaction before saving...", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtCash.Focus();
            }
            else if (Convert.ToDouble(txtCash.Text) < Convert.ToDouble(txtTotal.Text))
            {
                MessageBox.Show("Please check the cash tender...", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtCash.Focus();
            }
            else
            {
                SaveRentals();
            }
        }

        public void SaveRentals()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string Qty = string.Empty;
            string Amount = string.Empty;
            string Discount = string.Empty;
     

            DateTime d1 = DateTime.Now;
            
            string sRemark = "Payment for Sales Invoice with Ref # " + txtRentalID.Text.Trim();


            MySqlCommand cmd = new MySqlCommand();
            MySqlCommand Cash_Sales = new MySqlCommand();
            MySqlCommand Inv = new MySqlCommand();
            MySqlCommand Cash_Details = new MySqlCommand();

            for (int i=0; i< dgView.RowCount; i++ )
            {

                ItemNo = dgView.Rows[i].Cells[0].Value.ToString();
                Description = dgView.Rows[i].Cells[1].Value.ToString();
                UnitPrice = dgView.Rows[i].Cells[3].Value.ToString();
                Qty = dgView.Rows[i].Cells[2].Value.ToString();
                Amount = dgView.Rows[i].Cells[4].Value.ToString();
                Discount = dgView.Rows[i].Cells[5].Value.ToString();

                DateTime d2 = d1.AddDays(clsVariables.DefaultDays);

                cmd.CommandText = "Insert Into rentals(n_id,Rental_ID,products_id,Description,customers_id,DatedRented,DateDue,Status,RentPrice,TotalAmount,Quantity)" +
                              "Values ('" + myID + "','" + txtRentalID.Text + "','" + ItemNo + "','" + Description + "','" + lblCustomerID.Text + "','" + DateTime.Now.Date.ToShortDateString() + "','" + d2.ToShortDateString() + "','" + "On" + "','" + UnitPrice + "','" + Amount + "','" + Qty + "')";
                cmd.Connection = clsMySQL.con;
                cmd.ExecuteNonQuery();

                Inv.CommandText = "Update stockinv set EndingInv = EndingInv - " + Qty + ", InvUpdateDate ='" + DateTime.Now.ToShortDateString() + "' where products_id = '" + ItemNo + "'";
                Inv.Connection = clsMySQL.con;
                Inv.ExecuteNonQuery();

            }

            Cash_Sales.CommandText = "Insert Into cash_sales(CashSalesID,DateAdded,CreatedBy,InvoiceNo,Date,SoldTo,Gross,Discount,TaxBase,Vat,NetAmount,Tender,Changed,Remarks) " +
                                      "Values ('" + Invoice + "','" + DateTime.Now.Date.ToShortDateString() + "','" + clsVariables.fullname + "','" + txtInvoiceNo.Text + "','" + DateTime.Now.Date.ToShortDateString() + "','" + lblName.Text + "','" + txtSubTotal.Text + "','" + txtDiscount.Text + "','" + txtTax.Text + "','" + txtVat.Text + "','" + txtTotal.Text + "','" + txtCash.Text + "','" + txtChange.Text + "','" + sRemark + "')";
            Cash_Sales.Connection = clsMySQL.con;
            Cash_Sales.ExecuteNonQuery();

            Cash_Details.CommandText = "Insert Into cash_sales_details(CashSalesID,products_Title,Qty,Price,Discount) Values ('" + Invoice + "','" + Description + "','" + Qty +"','" + UnitPrice + "','" + Discount +"')";
            Cash_Details.Connection = clsMySQL.con;
            Cash_Details.ExecuteNonQuery();

            MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Rental" + "'", clsMySQL.con);
            pipz.ExecuteNonQuery();

            MySqlCommand pip = new MySqlCommand("Update Generator Set NextNo='" + Invoice + "' where TableName ='" + "Cash_Sales" + "'", clsMySQL.con);
            pip.ExecuteNonQuery();

            MessageBox.Show("Transaction Successfully Saved...");
            this.Close();
        }

        private void lblCustomerID_TextChanged(object sender, EventArgs e)
        {
            
        }

        private void cmdRemove_Click(object sender, EventArgs e)
        {
            if (dgView.SelectedRows.Count > 0)
            {
                dgView.Rows.RemoveAt(dgView.SelectedRows[0].Index);
                CalculateTotalPrice();
            }
            else
            {
                MessageBox.Show("Select one item to remove!");
            }
        }

        private void cmdViewCurrentRentals_Click(object sender, EventArgs e)
        {
            frmCurrentRentals rentals = new frmCurrentRentals();
            rentals.ShowRentals(lblCustomerID.Text);
        }

        private void txtproductID_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            { 
                SearchItem(txtproductID.Text);
                StockChecker(txtproductID.Text);
                txtQuantity.Text = "1";
                txtDisc.Text = "0";
                txtQuantity_TextChanged(this, new System.EventArgs());
            }
        }

        private void txtCash_TextChanged(object sender, EventArgs e)
        {
            
            if (txtCash.Text == "")
            {
                txtChange.Text = "0.00";
            }
            else
            {
                try
                {
                    decimal subTotal = (decimal.Parse(txtCash.Text) - decimal.Parse(txtTotal.Text));
                    txtChange.Text = String.Format("{0:0.##}", subTotal);
                }
                catch
                { }
            }
        }

        void StockChecker(string sProductId)
        {
            MySqlCommand check = new MySqlCommand("Select * from StockInv where products_id='" + sProductId + "'",clsMySQL.con);
            MySqlDataReader dr = check.ExecuteReader();
            while (dr.Read())
            {
                StockOnHand = Convert.ToInt32(dr["EndingInv"].ToString());
            }
            dr.Close();
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    
        private void txtQuantity_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Tab)
            {
                
            }
        }

        private void txtDescription_KeyDown(object sender, KeyEventArgs e)
        {
            SearchItemTitle(txtDescription.Text);
            StockChecker(txtproductID.Text);
            txtQuantity.Text = "1";
            txtDisc.Text = "0";
            txtQuantity_TextChanged(this, new System.EventArgs());
        }


   }
}
