﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmRentalLookUp : Form
    {
        
        public frmRentalLookUp()
        {
            InitializeComponent();
        }

        private void cmdSearch_Click(object sender, EventArgs e)
        {
            if (txtSearch.Text == "")
            {
                MessageBox.Show("Please dont leave empty the textfield when searching...", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                switch (cboField.SelectedIndex)
                {
                    case 0:
                        ShowItems(txtSearch.Text);
                        break;
                    case 1:
                        ShowTitles(txtSearch.Text);
                        break;
                    case 2:
                        ShowActor(txtSearch.Text);
                        break;
                    case 3:
                        ShowGenre(txtSearch.Text);
                        break;
                }
            }
        }

        private void cmdOK_Click(object sender, EventArgs e)
        {
            
            frmRental rent = new frmRental();
            rent.txtproductID.Text = clsVariables.RentalItems;
            rent.Focus();
            rent.Refresh();

            frmNoOfDays Days = new frmNoOfDays();
            Days.Show();
            this.Close();
        }

        private void frmRentalLookUp_Load(object sender, EventArgs e)
        {
            if (clsMySQL.con.State == ConnectionState.Open)
            { clsMySQL.con.Close(); }
            clsMySQL.con.Open();
        }

        public void ShowItems(string sItemNo)
        {
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;
            lvList.Items.Clear();
            cmd.CommandText = "Select * from qrymoviesearch where products_id LIKE '%" + sItemNo + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            while (dr.Read())
            {
            ListViewItem list = new ListViewItem(dr["products_id"].ToString());
                    list.SubItems.Add(dr["products_Title"].ToString());
                    list.SubItems.Add(dr["Rating"].ToString());
                    list.SubItems.Add(dr["Cast"].ToString());
                    list.SubItems.Add(dr["Genre"].ToString());
                    //list.SubItems.Add(dr[""].ToString());
                    list.SubItems.Add(dr["Location"].ToString());
                    lvList.Items.AddRange(new ListViewItem[] { list });
            }
            dr.Close();
        }

        public void ShowTitles(string sTitle)
        {
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;
            lvList.Items.Clear();

            cmd.CommandText = "Select * from qrymoviesearch where products_Title LIKE '%" + sTitle + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["products_id"].ToString());
                list.SubItems.Add(dr["products_Title"].ToString());
                list.SubItems.Add(dr["Rating"].ToString());
                list.SubItems.Add(dr["Cast"].ToString());
                list.SubItems.Add(dr["Genre"].ToString());
                list.SubItems.Add(dr["EndingInv"].ToString());
                list.SubItems.Add(dr["Location"].ToString());
                lvList.Items.AddRange(new ListViewItem[] { list });
            }
            dr.Close();
        }

        public void ShowActor(string sActor)
        {
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;
            lvList.Items.Clear();
            cmd.CommandText = "Select * from qrymoviesearch where Cast LIKE '%" + sActor + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["products_id"].ToString());
                list.SubItems.Add(dr["products_Title"].ToString());
                list.SubItems.Add(dr["Rating"].ToString());
                list.SubItems.Add(dr["Cast"].ToString());
                list.SubItems.Add(dr["Genre"].ToString());
                list.SubItems.Add(dr["EndingInv"].ToString());
                list.SubItems.Add(dr["Location"].ToString());
                lvList.Items.AddRange(new ListViewItem[] { list });
            }
            dr.Close();
        }

        public void ShowGenre(string sGenre)
        {
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;
            lvList.Items.Clear();
            cmd.CommandText = "Select * from qrymoviesearch where Genre LIKE '%" + sGenre + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["products_id"].ToString());
                list.SubItems.Add(dr["products_Title"].ToString());
                list.SubItems.Add(dr["Rating"].ToString());
                list.SubItems.Add(dr["Cast"].ToString());
                list.SubItems.Add(dr["Genre"].ToString());
                list.SubItems.Add(dr["EndingInv"].ToString());
                list.SubItems.Add(dr["Location"].ToString());
                lvList.Items.AddRange(new ListViewItem[] { list });
            }
            dr.Close();
        }

        private void lvList_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void rentItemToolStripMenuItem_Click(object sender, EventArgs e)
        {

                frmRental rent = new frmRental();
                rent.txtproductID.Text = lvList.FocusedItem.Text;
                rent.ShowDialog();

        }

        private void cboField_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cboField.Text)
            { 
                case "Item #":
                    AutoCompleteItemNo();
                    break;
                case "Title":
                    AutoCompleteTitle();
                    break;
                case "Actor":
                    AutoCompleteActor();
                    break;
                case "Genre":
                    AutoCompleteGenre();
                    break;
            }
        }

       public void AutoCompleteItemNo()
       {
           MySqlCommand Com = new MySqlCommand("Select * From products", clsMySQL.con);
           MySqlDataReader reader = Com.ExecuteReader();
           while (reader.Read())
           {txtSearch.AutoCompleteCustomSource.Add(reader["products_id"].ToString());}
           reader.Close();
       }

       public void AutoCompleteTitle()
       {
           MySqlCommand Com = new MySqlCommand("Select * From products", clsMySQL.con);
           MySqlDataReader reader = Com.ExecuteReader();
           while (reader.Read())
           { txtSearch.AutoCompleteCustomSource.Add(reader["products_Title"].ToString()); }
           reader.Close();
       }
       public void AutoCompleteActor()
       {
           MySqlCommand Com = new MySqlCommand("Select * From products", clsMySQL.con);
           MySqlDataReader reader = Com.ExecuteReader();
           while (reader.Read())
           { txtSearch.AutoCompleteCustomSource.Add(reader["Cast"].ToString()); }
           reader.Close();
       }
       public void AutoCompleteGenre()
       {
           MySqlCommand Com = new MySqlCommand("Select * From products", clsMySQL.con);
           MySqlDataReader reader = Com.ExecuteReader();
           while (reader.Read())
           { txtSearch.AutoCompleteCustomSource.Add(reader["Genre"].ToString()); }
           reader.Close();
       }

       private void txtSearch_KeyDown(object sender, KeyEventArgs e)
       {
           if (e.KeyCode == Keys.Enter)
           { 
            cmdSearch_Click(this, new System.EventArgs());
           }
       }
  }
}
