﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmReturn : Form
    {
        string CustomerNo, Status;
        public string CustomerName;

        int Invoice,Defaultdays;

        public frmReturn()
        {
            InitializeComponent();
        }

        private void frmReturn_Load(object sender, EventArgs e)
        {
            if (clsMySQL.con.State == ConnectionState.Open)
            { clsMySQL.con.Close(); }
            clsMySQL.con.Open();

            if (Convert.ToDateTime(dtpDate.Value.ToShortDateString()) > Convert.ToDateTime(txtDue.Text))
            { Status = "Penalty"; CheckStatus(); }
            else
            {
                Status = "No Penalty";
                CheckStatus();
            }
        }

        private void GenerateInvoice()
        {
            MySqlCommand cmddr = new MySqlCommand("select max(CashSalesID) as ids from cash_sales ", clsMySQL.con);
            MySqlDataReader dr = cmddr.ExecuteReader();
            while (dr.Read())
            {
                string strid = dr["ids"].ToString();
                if (strid == "" || strid == "0")
                {
                    this.txtInvoiceNo.Text = "Inv-" + "1";
                    Invoice = 1;
                }
                else
                {
                    Invoice = Convert.ToInt32(dr["ids"]) + 1;
                    txtInvoiceNo.Text = "Inv-" + Invoice.ToString();
                }
            }
            dr.Close();
            cmddr.Dispose();
        }

        private void cmdReturn_Click(object sender, EventArgs e)
        {
            switch (Status)
            { 
                case "Penalty":
                    if (txtAmount.Text == "0.00" || txtAmount.Text == "")
                    {
                        MessageBox.Show("Please settle the penalty before saving the transaction");
                        txtCashTender.Focus();
                    }
                    else if (Convert.ToDouble(txtAmount.Text) > Convert.ToDouble(txtCashTender.Text))
                    {
                        MessageBox.Show("Please enter a valid amount");
                        txtCashTender.Focus();
                    }
                    else
                    {
                        ReturnWithPenalty();
                    }
                    break;

                case "No Penalty":
                    ReturnItem();
                    break;
            }
        }

        void ReturnWithPenalty()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlCommand Cash_Sales = new MySqlCommand();
            MySqlCommand Inv = new MySqlCommand();

            com.CommandText = "Update rentals set Status= 'Off', DateReturn='" + dtpDate.Value.ToShortDateString() + "' where customers_id='" + CustomerNo + "' and Rental_ID = '" + txtRentalID.Text + "'";
            com.Connection = clsMySQL.con;
            com.ExecuteNonQuery();

            Inv.CommandText = "Update stockinv set EndingInv = EndingInv + " + Convert.ToInt32(txtQuantity.Text) + ", InvUpdateDate ='" + DateTime.Now.ToShortDateString() + "' where products_id = '" + txtItemNo.Text + "'";
            Inv.Connection = clsMySQL.con;
            Inv.ExecuteNonQuery();

            Cash_Sales.CommandText = "Insert Into cash_sales(CashSalesID,DateAdded,CreatedBy,InvoiceNo,Date,SoldTo,Gross,NetAmount,Tender,Changed) " +
                                      "Values ('" + Invoice + "','" + DateTime.Now.Date.ToShortDateString() + "','" + clsVariables.fullname + "','" + txtInvoiceNo.Text + "','" + DateTime.Now.Date.ToShortDateString() + "','" + CustomerName + "','" + txtAmount.Text + "','" + txtAmount.Text + "','" + txtCashTender.Text + "','" + txtChange.Text + "')";
            Cash_Sales.Connection = clsMySQL.con;
            Cash_Sales.ExecuteNonQuery();

            MessageBox.Show("Item Successfully return...", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
            this.Close();
        }

        void ReturnItem()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlCommand Cash_Sales = new MySqlCommand();
            MySqlCommand Inv = new MySqlCommand();

            com.CommandText = "Update rentals set Status= 'Off', DateReturn='" + dtpDate.Value.ToShortDateString() + "' where customers_id='" + CustomerNo + "' and Rental_ID = '" +txtRentalID.Text + "'";
            com.Connection = clsMySQL.con;
            com.ExecuteNonQuery();

            Inv.CommandText = "Update stockinv set EndingInv = EndingInv + " + Convert.ToInt32(txtQuantity.Text) + ", InvUpdateDate ='" + DateTime.Now.ToShortDateString() + "' where products_id = '" + txtItemNo.Text + "'";
            Inv.Connection = clsMySQL.con;
            Inv.ExecuteNonQuery();
         
            MessageBox.Show("Item Successfully return...","Front Desk Module",MessageBoxButtons.OK,MessageBoxIcon.Information);
            this.Close();
        }

        public void ShowReturn(string sRentalID, string sCustomerID,string sStatus)
        {
            MySqlCommand cmd = new MySqlCommand("Select * from rentals where Rental_ID='" + sRentalID + "' and customers_id='" + sCustomerID + "' and Status='" + sStatus + "'", clsMySQL.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                txtRentalID.Text = dr["Rental_ID"].ToString();
                txtDescription.Text = dr["Description"].ToString();
                CustomerNo = dr["customers_id"].ToString();
                txtQuantity.Text = dr["Quantity"].ToString();
                txtDateRented.Text = dr["DatedRented"].ToString();
                txtItemNo.Text = dr["products_id"].ToString();
                txtDue.Text = dr["DateDue"].ToString();
            }
            dr.Close();

             this.Focus();
            this.ShowDialog();
        }

        void CheckStatus()
        {
            TimeSpan calc;
            double a,fee;

            MySqlCommand com = new MySqlCommand("Select * From qrycustomerplan where customers_id='" + CustomerNo + "'",clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();

            if (Convert.ToDateTime(dtpDate.Value.ToShortDateString()) > Convert.ToDateTime(txtDue.Text))
            {
                lblNote.Visible = true;
                grpPayment.Visible = true;
                grpPenalty.Visible = true;

                while (dr.Read())
                {
                    txtLateFeePerDay.Text = dr["LateFeePerDay"].ToString();
                }
                dr.Close();

                calc = Convert.ToDateTime(dtpDate.Value.ToShortDateString()) - Convert.ToDateTime(txtDue.Text);
                a = calc.TotalDays;
                txtDays.Text = a.ToString();

                fee = Convert.ToDouble(txtLateFeePerDay.Text) * Convert.ToDouble(txtDays.Text);
                txtAmount.Text = fee.ToString();

                GenerateInvoice();
                Status = "Penalty";
                GenerateInvoice();

            }
            else
            {
                dr.Close();
                lblNote.Visible = false;
                grpPayment.Visible = false;
                grpPenalty.Visible = false;
                Status = "No Penalty";
            }
        }

        private void dtpDate_ValueChanged(object sender, EventArgs e)
        {
            CheckStatus();
        }

        private void txtCashTender_TextChanged(object sender, EventArgs e)
        {
            double amount;

            if (txtCashTender.Text == "")
            {
                txtChange.Text = "0.00";
            }
            else
            {
                amount = Convert.ToDouble(txtCashTender.Text) - Convert.ToDouble(txtAmount.Text);
                txtChange.Text = amount.ToString();
            }
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
