﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmSalesOrder : Form
    {
        public frmSalesOrder()
        {
            InitializeComponent();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            frmSalesOrderAE SalesOrder = new frmSalesOrderAE();
            SalesOrder.mFormState = "ADD";
            SalesOrder.Show();
        }

        private void frmSalesOrder_Load(object sender, EventArgs e)
        {
            try
            {
                if (clsMySQL.con.State == ConnectionState.Open)
                { clsMySQL.con.Close(); }
                clsMySQL.con.Open();
                FillListView();
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        public void FillListView()
        {
            MySqlCommand com = new MySqlCommand("Select SONo, Fullname, Date, Salesman, QtyOrdered, QtyRcvd, QtyDue, SalesOrderID From qry_Sales_Order Order By Date DESC",clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            listView1.Items.Clear();
            while (dr.Read())
            {
                ListViewItem lv = new ListViewItem(dr["SONo"].ToString());
                lv.SubItems.Add(dr["Fullname"].ToString());
                lv.SubItems.Add(dr["Date"].ToString());
                lv.SubItems.Add(dr["Salesman"].ToString());
                lv.SubItems.Add(dr["QtyOrdered"].ToString());
                lv.SubItems.Add(dr["QtyRcvd"].ToString());
                lv.SubItems.Add(dr["QtyDue"].ToString());
                lv.SubItems.Add(dr["SalesOrderID"].ToString());
                listView1.Items.AddRange(new ListViewItem[] { lv });
                lv.ImageIndex.Equals(1);
            }
            dr.Close();
        }

        public void ModifySalesOrder()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader read;
            MySqlDataReader dr;


            frmSalesOrderAE frm = null;
            foreach (Form f in this.MdiChildren)
            {
                if (f is frmSalesOrderAE)
                {
                    frm = (frmSalesOrderAE)f;
                    break;
                }
            }
            if (frm == null)
            {
                frm = new frmSalesOrderAE();
                frm.mFormState = "EDIT";
            }
            com.CommandText = "Select * from qry_sales_order where SalesOrderID='" + listView1.Items[listView1.FocusedItem.Index].SubItems[7].Text + "'";
            com.Connection = clsMySQL.con;
            read = com.ExecuteReader();
            while (read.Read())
            {
                frm.myID = Convert.ToInt32(listView1.Items[listView1.FocusedItem.Index].SubItems[7].Text);
                frm.txtSONo.Text = read["SONo"].ToString();
                frm.txtSoldTo.Text = read["Fullname"].ToString();
                frm.txtCustomerID.Text = read["customers_id"].ToString();
                frm.txtDate.Text = read["Date"].ToString();
                frm.txtSalesman.Text = read["Salesman"].ToString();
                frm.txtAddress.Text = read["PermanentAddress"].ToString();
                frm.txtOrderedBy.Text = read["OrderedBy"].ToString();
                frm.txtDispatched.Text = read["DispatchedBy"].ToString();
                frm.txtInstructions.Text = read["DeliveryInstructions"].ToString();
                frm.txtGrosse.Text =  read["Gross"].ToString();
                frm.txtDiscount.Text = read["Discount"].ToString();
                frm.txtTaxBase.Text = read["TaxBase"].ToString();
                frm.txtVAT.Text = read["Vat"].ToString();
                frm.txtNet.Text = read["NetAmount"].ToString();
                frm.txtRemarks.Text = read["Remarks"].ToString();
            }
            read.Close();

            cmd.CommandText = "Select * From qry_Sales_Order_Detail where SalesOrderID='" + listView1.Items[listView1.FocusedItem.Index].SubItems[7].Text+ "'";
            cmd.Connection = clsMySQL.con;
            dr = cmd.ExecuteReader();
            while (dr.Read())
                {
                    int n = frm.dgView.Rows.Add();
                    frm.dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                    frm.dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                    frm.dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                    frm.dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                    frm.dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                    frm.dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                    frm.dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                    frm.dgView.FirstDisplayedScrollingRowIndex = n;
                    frm.dgView.CurrentCell = frm.dgView.Rows[n].Cells[0];
                    frm.dgView.Rows[n].Selected = true;
                }
                dr.Close();

                frm.dtpDate.Visible = false;
                frm.txtDate.Visible = true;
                frm.cmdSave.Visible = true;
                frm.cmdAdd.Visible = true;
                frm.CmdReceiveItem.Left = frm.cmdSave.Left;
                frm.CmdReceiveItem.Visible = true;
            frm.Focus();
            frm.ShowDialog();
        }

        private void btn_Refresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        private void btn_close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btn_Edit_Click(object sender, EventArgs e)
        {
            ModifySalesOrder();
        }

        private void btn_Delete_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to void the selected record?\n\n WARNING: You cannot undo this operation.This will permanently remove the record.", "Confirm Record", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                MySqlCommand command = new MySqlCommand("DELETE FROM Sales_Order WHERE SONo ='" + listView1.FocusedItem.Text + "'", clsMySQL.con);
                command.ExecuteNonQuery();

                MessageBox.Show("Record has been successfully removed.");
            }
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            ModifySalesOrder();
        }

        private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

   }
}
