﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmSalesOrderAE : Form
    {
        public string mFormState;
        public int myID;

        int StockOnHand;

        public frmSalesOrderAE()
        {
            InitializeComponent();
        }

        private void frmSalesOrderAE_Load(object sender, EventArgs e)
        {

            try
            {
                if (clsMySQL.con.State == ConnectionState.Open)
                { clsMySQL.con.Close(); }
                clsMySQL.con.Open();

                switch (mFormState)
                { 
                    case "ADD":
                        ItemAutoComplete();
                        AutoCompleteCustomer();
                        GenerateSalesOrder();

                        cmdPrintPreview.Visible = false;
                        dtpDate.Value = DateTime.Now;
                        this.Text = "Create New Entry";
                        cmdModificationHistory.Enabled = false;
                        
                    break;

                    case "EDIT":
                        ItemAutoComplete();
                        AutoCompleteCustomer();

                        cmdPrintPreview.Visible = true;
                        cmdCancel.Text = "Close";
                        cmdModificationHistory.Enabled = true;
                        txtRemarks.Text = myID.ToString();
                    break;
                }
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void GenerateSalesOrder()
        {
            MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator where TableName='" + "Sales_Order" + "'", clsMySQL.con);
            MySqlDataReader dr = cmddr.ExecuteReader();
            while (dr.Read())
            {
                string strid = (dr["NextNo"].ToString());
                if (strid == "")
                {
                    txtSONo.Text = "SO-" + "1";
                    myID = 1;
                }
                else
                {
                    myID = Convert.ToInt32(dr["NextNo"]) + 1;
                    txtSONo.Text = "SO-" + myID.ToString();
                }
            }
            dr.Close();
        }

        void ItemAutoComplete()
        {
            MySqlCommand com = new MySqlCommand("Select products_Title,products_id From products",clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtStock.AutoCompleteCustomSource.Add(dr["products_Title"].ToString());
            }
            dr.Close();
        }

        void AutoCompleteCustomer()
        {
            MySqlCommand com = new MySqlCommand("Select Fullname, customers_id From qrycustomers_detail",clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtSoldTo.AutoCompleteCustomSource.Add(dr["Fullname"].ToString());
            }
            dr.Close();
        }

        void CustomerIDNo(string sID)
        {
            MySqlCommand com = new MySqlCommand("Select * From qrycustomers_detail where Fullname Like '%" + sID + "%'", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtCustomerID.Text=dr["customers_id"].ToString();
                txtAddress.Text = dr["PermanentAddress"].ToString();
            }
            dr.Close();
        }

        void SearchItem(string ItemNo)
        {
            decimal UnitPrice;

            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            cmd.CommandText = "Select * From products where products_Title Like '%" + ItemNo.Trim() + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                txtStockNo.Text = (String)dr["products_id"].ToString();
                txtStock.Text = (String)dr["products_Title"].ToString();
                UnitPrice = Convert.ToDecimal(dr["SellingPrice"].ToString());
                txtUnitPrice.Text = String.Format("{0:0.##}", UnitPrice);
            }
            dr.Close();
        }


        void Clear()
        {
            txtStockNo.Text = "";
            txtStock.Text = "";
            txtQty.Text = "";
            txtUnitPrice.Text = "";
            txtGross.Text = "";
            txtDisc.Text = "";
            txtNetAmount.Text = "";
        }

        private void txtStock_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                SearchItem(txtStock.Text);
                StockChecker(txtStockNo.Text);
                txtQty.Text = "1";
                txtDisc.Text = "0";
                txtQty_TextChanged(this, new System.EventArgs());
            }
        }

        void StockChecker(string sProductId)
        {
            MySqlCommand check = new MySqlCommand("Select * from StockInv where products_id='" + sProductId + "'", clsMySQL.con);
            MySqlDataReader dr = check.ExecuteReader();
            while (dr.Read())
            {
                StockOnHand = Convert.ToInt32(dr["EndingInv"].ToString());
            }
            dr.Close();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            if (txtStock.Text == "")
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.");
            }
            if (StockOnHand < Convert.ToInt32(txtQty.Text))
            {
                MessageBox.Show("Sorry item is out of stock.\n Please select other item..");
                txtStock.Focus();
            }
            else if (StockOnHand <= 0)
            {
                MessageBox.Show("Sorry item is out of stock.\n Please select other item..");
                txtStock.Focus();
            }
            else
            {
                for (int row = 0; row < dgView.Rows.Count; row++)
                    {
                        for (int col = 0; col < dgView.Columns.Count; col++)
                        {
                            if (dgView.Rows[row].Cells[col].Value != null &&
                              dgView.Rows[row].Cells[col].Value.Equals(label1.Text.Trim()))
                            {
                                MessageBox.Show("Item Already Exist...");
                                return;
                            }
                        }
                    }

                int n = dgView.Rows.Add();
                //int intQtyOrdered = int.Parse(txtQty.Text);

                dgView.Rows[n].Cells[0].Value = txtStockNo.Text;
                dgView.Rows[n].Cells[1].Value = txtStock.Text;
                dgView.Rows[n].Cells[2].Value = txtQty.Text;
                dgView.Rows[n].Cells[3].Value = txtUnitPrice.Text;
                dgView.Rows[n].Cells[4].Value = txtGross.Text;
                dgView.Rows[n].Cells[5].Value = txtDisc.Text;
                dgView.Rows[n].Cells[6].Value = txtNetAmount.Text;
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;

                Clear();
                CalculateTotalPrice();
                }
        }

        void CalculateTotalPrice()
        {
            //Initial Amount
            decimal tGross = 0;
            decimal tNet = 0;
            decimal tAX = 0;
            decimal tVat = 0;
            //Quantity
            int Quan = 0;
            int Quant = 0;
            int Quanti = 0;
            //Discount
            decimal cDAmount = 0;
            decimal price = 0;

            int i = dgView.RowCount;

            for (int a = 0; a < i; a++)
            {
                try
                {
                    //Initial Total of items in list
                    tGross += decimal.Parse(dgView.Rows[a].Cells[4].Value.ToString());
                    tNet += decimal.Parse(dgView.Rows[a].Cells[6].Value.ToString());
                    //Total Quantity of items in list
                    Quan += int.Parse(dgView.Rows[a].Cells[2].Value.ToString());
                    //Total Price
                    price += decimal.Parse(dgView.Rows[a].Cells[3].Value.ToString());
                    //Total Discount of items in list
                    cDAmount = cDAmount + Convert.ToDecimal((Convert.ToDecimal(dgView.Rows[a].Cells[5].Value.ToString()) / 100) * (Convert.ToDecimal(Quan) * Convert.ToDecimal(price)));
                }
                catch (Exception)
                {
                }
            }
            Quanti = Quant + Quan;
            tAX = (tNet / 1.12m);
            tVat = tNet - Convert.ToDecimal(tAX);

            txtDiscount.Text = cDAmount.ToString();

            txtGrosse.Text = String.Format("{0:0.##}", tGross);
            txtNet.Text = String.Format("{0:0.##}", tNet);
            txtTaxBase.Text = String.Format("{0:0.##}",(tAX));
            txtVAT.Text = String.Format("{0:0.##}", tVat);
        }
        private void txtSoldTo_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                CustomerIDNo(txtSoldTo.Text);
            }
        }

        private void txtQty_TextChanged(object sender, EventArgs e)
        {
            decimal Total;
            decimal sum = 0;

            if (txtQty.Text.Equals("") || txtDisc.Text.Equals(""))
            {
                txtNetAmount.Text = "0.00";
            }
            else
            {
                try
                {
                    int quantity = int.Parse(txtQty.Text);
                    decimal unitprice = decimal.Parse(txtUnitPrice.Text);
                    decimal discount = decimal.Parse(txtDisc.Text);


                    Total = decimal.Parse(txtUnitPrice.Text) * decimal.Parse(txtQty.Text);
                    txtGross.Text = String.Format("{0:0.##}", Total);

                    sum = Convert.ToDecimal(Total - ((discount / 100) * Total));
                    txtNetAmount.Text = sum.ToString();
                }
                catch
                { }
            }
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (dgView.RowCount < 1)
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.","Front Desk Module",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
                txtStock.Focus();
            }
           
            if (txtSoldTo.Text == "")
            {
                MessageBox.Show("Please select a client.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtSoldTo.Focus();
            }

            if (MessageBox.Show("This save the record. Do you want to proceed?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                SaveSalesOrder();
            }
            
        }

        void SaveSalesOrder()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string UnitType = string.Empty;
            string Qty = string.Empty;
            string netAmount = string.Empty;
            string Discount = string.Empty;

            MySqlCommand Sales_Order = new MySqlCommand();
            MySqlCommand Sales_Order_Details = new MySqlCommand();

            Sales_Order.CommandText = "Insert Into sales_order(SalesOrderID,CreatedBy,CreatedOn,customers_id,SONo,Date,Salesman,OrderedBy,DispatchedBy,DeliveryInstructions,Gross,Discount,TaxBase,Vat,NetAmount,Remarks) " +
                                          "Values ('" + myID + "','" + clsVariables.fullname + "','" + DateTime.Now.Date.ToShortDateString() + "','" + txtCustomerID.Text + "','" + txtSONo.Text + "','" + dtpDate.Value.ToShortDateString() + "','" + txtSalesman.Text +
                                          "','" + txtOrderedBy.Text + "','" + txtDispatched.Text + "','" + txtInstructions.Text + "','" + txtGrosse.Text + "','" + txtDiscount.Text + "','" + txtTaxBase.Text + "','" + txtVAT.Text + "','" + txtNet.Text + "','" + txtRemarks.Text + "')";
            Sales_Order.Connection = clsMySQL.con;
            Sales_Order.ExecuteNonQuery();

            MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Sales_Order" + "'", clsMySQL.con);
            pipz.ExecuteNonQuery();

            for (int n = 0; n < dgView.RowCount; n++)
            {
                ItemNo = dgView.Rows[n].Cells[0].Value.ToString();
                Description = dgView.Rows[n].Cells[1].Value.ToString();
                Qty = dgView.Rows[n].Cells[2].Value.ToString();
                UnitPrice = dgView.Rows[n].Cells[3].Value.ToString();
                Discount = dgView.Rows[n].Cells[5].Value.ToString();
                netAmount = dgView.Rows[n].Cells[6].Value.ToString();

                Sales_Order_Details.CommandText = "Insert Into sales_order_details(SalesOrderID,products_id,Qty,Price,Discount,CreatedBy,CreatedOn) " +
                                                    "Values('" + myID + "','" + ItemNo + "','" + Qty + "','" + UnitPrice + "','" + Discount + "','" + clsVariables.fullname + "','" + DateTime.Now.ToShortDateString() + "')";
                Sales_Order_Details.Connection = clsMySQL.con;
                Sales_Order_Details.ExecuteNonQuery();

            }

            MessageBox.Show("New record has been successfully saved.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
            frmSalesOrder sales = new frmSalesOrder();
            sales.FillListView();
            this.Close();
        }

        private void cmdPrintPreview_Click(object sender, EventArgs e)
        {
            frmPrintPreview preview = new frmPrintPreview();
            preview.WindowState = FormWindowState.Maximized;
            preview.strReport = "Sales Order";
            preview.strWhere = "{Sales_Order.SONo} ='" + txtSONo.Text + "'";
            preview.Show();
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void CmdReceiveItem_Click(object sender, EventArgs e)
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Sales_Order_Detail WHERE SalesOrderID=" + myID + " AND QtyDue > 0 ORDER BY products_id ASC",clsMySQL.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                frmSalesOrderDeliveryAE deliver = new frmSalesOrderDeliveryAE();
                deliver.mFormState = "ADD";
                deliver.myID = myID;

                deliver.ShowDialog();
            }
            else
            {
                MessageBox.Show("All items are already received.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                dr.Close();
            }
        }


    }
}