﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmSalesOrderDeliveryAE : Form
    {
        public string mFormState;
        public int myID, AutoN;

        decimal cIGross, cIAmount, cDAmount;

        public frmSalesOrderDeliveryAE()
        {
            InitializeComponent();
        }

        private void frmSalesOrderDeliveryAE_Load(object sender, EventArgs e)
        {
            try
            {
                if (clsMySQL.con.State == ConnectionState.Open)
                { clsMySQL.con.Close(); }
                clsMySQL.con.Open();
                switch (mFormState)
                {
                    case "ADD":
                        dtpDeliveryDate.Value = DateTime.Now;
                        this.Text = "Create New Entry";
                        cmdModificationHistory.Enabled = false;

                        GenerateDeliveryNo();
                        DisplayForEditing();
                        ItemAutoComplete();
                        txtRemarks.Text = myID.ToString();
                        break;
                    case "EDIT":
                        cmdCancel.Text = "Close";
                        DisplayForViewing();
                        ItemAutoComplete();
                        break;
                }
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        void ItemAutoComplete()
        {
            MySqlCommand com = new MySqlCommand("Select products_Title,products_id From products", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtStock.AutoCompleteCustomSource.Add(dr["products_Title"].ToString());
            }
            dr.Close();
        }

        private void GenerateDeliveryNo()
        {
            MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator Where TableName='" +"Sales_Order_Delivery"+ "'", clsMySQL.con);
            MySqlDataReader dr = cmddr.ExecuteReader();
            while (dr.Read())
            {
                string strid = dr["NextNo"].ToString();
                if (strid == "")
                {
                    txtSONo.Text = "SOD-" + "1";
                    AutoN = 1;
                }
                else
                {
                    AutoN = Convert.ToInt32(dr["NextNo"]) + 1;
                    txtSONo.Text = "SOD-" + AutoN.ToString();
                }
            }
            dr.Close();
            cmddr.Dispose();
        }



        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        public void DisplayForEditing()
        {

            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Sales_Order WHERE SalesOrderID='" + myID + "'", clsMySQL.con);
            MySqlDataReader rs = cmd.ExecuteReader();
            while (rs.Read())
            {
                nsdClient.Text = rs["Fullname"].ToString();
                txtSONo.Text = rs["SONo"].ToString();
                txtAddress.Text = rs["PermanentAddress"].ToString();
                txtDate.Text = rs["Date"].ToString();
 
                txtGrosse.Text = rs["Gross"].ToString();
                txtDiscount.Text = rs["Discount"].ToString();
                txtTaxBase.Text = rs["TaxBase"].ToString();
                txtVAT.Text = rs["Vat"].ToString();
                txtNet.Text = rs["NetAmount"].ToString();
                txtRemarks.Text = rs["Remarks"].ToString();

                cIGross = Convert.ToDecimal(txtGrosse.Text);
                cIAmount = Convert.ToDecimal(txtNet.Text);
                cDAmount = Convert.ToDecimal(txtDiscount.Text);
            }
            rs.Close();

            MySqlCommand com = new MySqlCommand("Select * From qry_sales_order_detail where SalesOrderID='" + myID + "'", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

            dtpDeliveryDate.Visible = true;
            txtDeliveryDate.Visible = false;
        }


        void DisplayForViewing()
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Sales_Order_Delivery WHERE SalesOrderID=" + myID + "", clsMySQL.con);
            MySqlDataReader rs = cmd.ExecuteReader();
            while (rs.Read())
            {
                nsdClient.Text = rs["Fullname"].ToString();
                txtSONo.Text = rs["SONo"].ToString();
                txtAddress.Text = rs["PermanentAddress"].ToString();
                txtDate.Text = rs["Date"].ToString();
                txtDeliveryNo.Text = rs["DeliveryNo"].ToString();

                txtGrosse.Text = rs["Gross"].ToString();
                txtDiscount.Text = rs["Discount"].ToString();
                txtTaxBase.Text = rs["TaxBase"].ToString();
                txtVAT.Text = rs["Vat"].ToString();
                txtNet.Text = rs["NetAmount"].ToString();

                cIGross = Convert.ToDecimal(txtGrosse.Text);
                cIAmount = Convert.ToDecimal(txtNet.Text);
                cDAmount = Convert.ToDecimal(txtDiscount.Text);
            }
            rs.Close();

            MySqlCommand com = new MySqlCommand("Select * From qry_Sales_Order_Delivery_Detail where DeliveryID='" + myID + "'", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

            dtpDeliveryDate.Visible = true;
            txtDeliveryDate.Visible = false;
            picPurchase.Visible = false;
            cmdSave.Visible = false;
            cmdUpdate.Visible = false;

            CmdReturn.Left = cmdSave.Left;
            CmdReturn.Visible = true;
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (txtDeliveryNo.Text == "")
            {
                MessageBox.Show("Please enter delivery number before saving this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (dgView.RowCount < 1)
            {
                MessageBox.Show("Please enter item to return before saving this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if (MessageBox.Show("This save the record. Do you want to proceed?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    SaveRecord();
                }
            }
        }

        void SaveRecord()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string UnitType = string.Empty;
            string Qty = string.Empty;
            string netAmount = string.Empty;
            string Discount = string.Empty;

            string sSQL1 = "Insert Into Sales_Order_Delivery(DeliveryID,SalesOrderID,DeliveryNo,DeliveryDate,CheckedBy,Frieght,Terms,Remarks,Gross,Discount,TaxBase,Vat,NetAmount,CreatedOn,CreatedBy) " +
                          "Values('" + myID + "','" + myID + "','" + txtDeliveryNo.Text + "','" + dtpDeliveryDate.Value.ToShortDateString() + "','" + txtCheckedBy.Text + "','" + txtFrieght.Text +
                           "','" + txtTerms.Text + "','" + txtRemarks.Text + "','" + txtGrosse.Text + "','" + txtDiscount.Text + "','" + txtTaxBase.Text + "','" + txtVAT.Text + "','" + txtNet.Text +
                           "','" + DateTime.Now.ToShortDateString() + "','" + clsVariables.fullname + "')";

            MySqlCommand com = new MySqlCommand(sSQL1, clsMySQL.con);
            com.ExecuteNonQuery();

            for (int n = 0; n < dgView.RowCount; n++)
            {
                ItemNo = dgView.Rows[n].Cells[0].Value.ToString();
                Description = dgView.Rows[n].Cells[1].Value.ToString();
                Qty = dgView.Rows[n].Cells[2].Value.ToString();
                UnitPrice = dgView.Rows[n].Cells[3].Value.ToString();
                Discount = dgView.Rows[n].Cells[5].Value.ToString();
                netAmount = dgView.Rows[n].Cells[6].Value.ToString();

                string sSQL2 = "Insert Into Sales_Order_Delivery_Detail(DeliveryID,products_id,Qty,Price,Discount) Values ('" + myID +
                                "','" + ItemNo + "','" + Qty + "','" + UnitPrice + "','" + Discount + "')";
                MySqlCommand cmd = new MySqlCommand(sSQL2, clsMySQL.con);
                cmd.ExecuteNonQuery();

                string sSQL3 = "Update Sales_Order_Details set QtyReceived = QtyReceived + " + Qty + " where products_id='" + ItemNo + "'";
                MySqlCommand up = new MySqlCommand(sSQL3, clsMySQL.con);
                up.ExecuteNonQuery();
            }

            MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Sales_Order" + "'", clsMySQL.con);
            pipz.ExecuteNonQuery();


            if (mFormState == "ADD")
            {
                MessageBox.Show("New record has been successfully saved.");
                this.Close();
            }
        }

        private void CmdReturn_Click(object sender, EventArgs e)
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Sales_Order_Delivery_Detail WHERE DeliveryID='" + myID + "' AND QtyDue > 0 ORDER BY products_id ASC", clsMySQL.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                frmSalesOrderReturnAE returns = new frmSalesOrderReturnAE();
                returns.mFormState = "ADD";
                returns.myID = myID;
                returns.ShowDialog();
            }
            else
            {
                MessageBox.Show("All items are already received.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                dr.Close();
            }
        }

        private void txtQty_TextChanged(object sender, EventArgs e)
        {
            decimal Total;
            decimal sum = 0;

            if (txtQty.Text.Equals("") || txtDisc.Text.Equals(""))
            {
                txtNetAmount.Text = "0.00";
            }
            else
            {
                int quantity = int.Parse(txtQty.Text);
                decimal unitprice = decimal.Parse(txtUnitPrice.Text);
                decimal discount = decimal.Parse(txtDisc.Text);


                Total = decimal.Parse(txtUnitPrice.Text) * decimal.Parse(txtQty.Text);
                txtGross.Text = String.Format("{0:0.##}", Total.ToString());

                sum = Convert.ToDecimal(Total - ((discount / 100) * Total));
                txtNetAmount.Text = sum.ToString();

            }
        }
        void SearchItem(string ItemNo)
        {
            decimal UnitPrice;

            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            cmd.CommandText = "Select * From products where products_Title Like '%" + ItemNo.Trim() + "%'";
            cmd.Connection = clsMySQL.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                txtStockNo.Text = (String)dr["products_id"].ToString();
                txtStock.Text = (String)dr["products_Title"].ToString();
                UnitPrice = Convert.ToDecimal(dr["SellingPrice"].ToString());
                txtUnitPrice.Text = String.Format("{0:0.##}", UnitPrice);
            }
            dr.Close();
        }
        private void txtStock_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                SearchItem(txtStock.Text);
            }
        }
        private void dgView_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            int n = dgView.CurrentRow.Index;

            txtStockNo.Text = dgView.Rows[n].Cells[0].Value.ToString();
            txtStock.Text = dgView.Rows[n].Cells[1].Value.ToString();
            txtQty.Text = dgView.Rows[n].Cells[2].Value.ToString();
            txtUnitPrice.Text = dgView.Rows[n].Cells[3].Value.ToString();
            txtGross.Text = dgView.Rows[n].Cells[4].Value.ToString();
            txtDisc.Text = dgView.Rows[n].Cells[5].Value.ToString();
            txtNetAmount.Text = dgView.Rows[n].Cells[6].Value.ToString();
        }

   }
}