﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmSalesOrderReturn : Form
    {
        public frmSalesOrderReturn()
        {
            InitializeComponent();
        }

        private void frmSalesOrderReturn_Load(object sender, EventArgs e)
        {
            try
            {
                if (clsMySQL.con.State == ConnectionState.Open)
                { clsMySQL.con.Close(); }
                clsMySQL.con.Open();
                FillListView();
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        void FillListView()
        {
            MySqlCommand com = new MySqlCommand("Select SONo, Fullname, DeliveryNo, DeliveryDate, QtyReturned, SalesOrderReturnID From qry_Sales_Order_Return Order By DeliveryDate DESC", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            listView1.Items.Clear();
            while (dr.Read())
            {
                ListViewItem lv = new ListViewItem(dr["SONo"].ToString());
                lv.SubItems.Add(dr["Fullname"].ToString());
                lv.SubItems.Add(dr["DeliveryNo"].ToString());
                lv.SubItems.Add(dr["DeliveryDate"].ToString());
                lv.SubItems.Add(dr["QtyReturned"].ToString());
                lv.SubItems.Add(dr["SalesOrderReturnID"].ToString());
                listView1.Items.AddRange(new ListViewItem[] { lv });
                lv.ImageIndex.Equals(1);
            }
            dr.Close();
        }

        private void btn_Refresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        private void btn_Add_Click(object sender, EventArgs e)
        {
            frmSalesOrderReturnAE salesreturn = new frmSalesOrderReturnAE();
            salesreturn.mFormState = "ADD";
            salesreturn.ShowDialog();
        }

        private void btn_Edit_Click(object sender, EventArgs e)
        {
            frmSalesOrderReturnAE salesreturn = new frmSalesOrderReturnAE();
            salesreturn.mFormState = "EDIT";
            salesreturn.myID = Convert.ToInt32(listView1.Items[listView1.FocusedItem.Index].SubItems[6].Text);
            salesreturn.ShowDialog();
        }

        private void btn_Delete_Click(object sender, EventArgs e)
        {

        }
    }
}
