﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmSalesOrderReturnAE : Form
    {
        public string mFormState;
        public int myID;

        decimal cIGross;
        decimal cIAmount;
        decimal cDAmount;

        public frmSalesOrderReturnAE()
        {
            InitializeComponent();
        }

        private void frmSalesOrderReturnAE_Load(object sender, EventArgs e)
        {
            try
            {
                if (clsMySQL.con.State == ConnectionState.Open)
                { clsMySQL.con.Close(); }
                clsMySQL.con.Open();

                switch (mFormState)
                { 
                    case"ADD":
                        dtpCreditMemoDate.Value = DateTime.Now;
                        dtpDate.Value = DateTime.Now;
                        this.Text = "Create New Entry";
                        cmdModificationHistory.Enabled = false;

                        DisplayForEditing();
                        GenerateReturnNo();
                        ItemAutoComplete();
                        break;
                    case "EDIT":
                        cmdCancel.Text = "Close";
                        DisplayForViewing();
                        ItemAutoComplete();
                        break;
                }

            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            
        }

        private void GenerateReturnNo()
        {
            MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator where TableName ='" + "Sales_Order_Delivery" + "'", clsMySQL.con);
            MySqlDataReader dr = cmddr.ExecuteReader();
            while (dr.Read())
            {
                string strid = dr["NextNo"].ToString();
                if (strid == "")
                {
                    txtSONo.Text = "SOR-" + "1";
                    myID = 1;
                }
                else
                {
                    myID = Convert.ToInt32(dr["NextNo"]) + 1;
                    txtSONo.Text = "SOR-" + myID.ToString();
                }
            }
            dr.Close();
            cmddr.Dispose();
        }

        void ItemAutoComplete()
        {
            MySqlCommand com = new MySqlCommand("Select products_Title,products_id From products", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtStock.AutoCompleteCustomSource.Add(dr["products_Title"].ToString());
            }
            dr.Close();
        }
        void DisplayForViewing()
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Sales_Order_Return WHERE SalesOrderReturnID='" + myID + "'", clsMySQL.con);
            MySqlDataReader rs = cmd.ExecuteReader();
            while (rs.Read())
            {
                txtSoldTo.Text = rs["Fullname"].ToString();
                txtSONo.Text = rs["SONo"].ToString();
                txtDeliveryNo.Text = rs["DeliveryNo"].ToString();
                txtDeliveryDate.Text = rs["DeliveryDate"].ToString();

                txtCreditMemoNo.Text = rs["CreditMemoNo"].ToString();
                txtCreditMemoNo.Text = rs["CreditMemoNo"].ToString();
                txtDate.Text = rs["Date"].ToString();
                txtReason.Text = rs["Reason"].ToString();
                txtReference.Text = rs["Referrence"].ToString();
                txtPreparedBy.Text = rs["PreparedBy"].ToString();
                txtReceivedBy.Text = rs["ReceivedBy"].ToString();
                txtPostedBy.Text = rs["PostedBy"].ToString();
                txtApprovedBy.Text = rs["ApprovedBy"].ToString();
                txtDate.Text = rs["Date"].ToString();
                txtAcknowledgedBy.Text = rs["AcknowledgedBy"].ToString();

                txtGrosse.Text = rs["Gross"].ToString();
                txtDiscount.Text = rs["Discount"].ToString();
                txtTaxBase.Text = rs["TaxBase"].ToString();
                txtVAT.Text = rs["Vat"].ToString();
                txtNet.Text = rs["NetAmount"].ToString();
                txtRemarks.Text = rs["Remarks"].ToString();

                cIGross = Convert.ToDecimal(txtGrosse.Text);
                cIAmount = Convert.ToDecimal(txtNet.Text);
                cDAmount = Convert.ToDecimal(txtDiscount.Text);
            }
            rs.Close();

            MySqlCommand com = new MySqlCommand("Select * From qry_Sales_Order_Return_Detail where SalesOrderReturnID='" + myID + "'", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

            dtpCreditMemoDate.Visible = false;
            txtCreditMemoNo.Visible = true;
            dtpDate.Visible = false;
            txtDate.Visible = true;
            picPurchase.Visible = false;
            cmdSave.Visible = false;
            cmdAdd.Visible = false;
        }

        void DisplayForEditing()
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Sales_Order_Delivery WHERE DeliveryID='" + myID + "'", clsMySQL.con);
            MySqlDataReader rs = cmd.ExecuteReader();
            while (rs.Read())
            {
                txtSoldTo.Text = rs["Fullname"].ToString();
                txtSONo.Text = rs["SONo"].ToString();
                txtDeliveryNo.Text = rs["DeliveryNo"].ToString();
                txtDeliveryDate.Text = rs["DeliveryDate"].ToString();
                txtDate.Text = rs["Date"].ToString();

                txtGrosse.Text = rs["Gross"].ToString();
                txtDiscount.Text = rs["Discount"].ToString();
                txtTaxBase.Text = rs["TaxBase"].ToString();
                txtVAT.Text = rs["Vat"].ToString();
                txtNet.Text = rs["NetAmount"].ToString();
                txtRemarks.Text = rs["Remarks"].ToString();

                cIGross = Convert.ToDecimal(txtGrosse.Text);
                cIAmount = Convert.ToDecimal(txtNet.Text);
                cDAmount = Convert.ToDecimal(txtDiscount.Text);
            }
            rs.Close();

            MySqlCommand com = new MySqlCommand("Select * From qry_Sales_Order_Delivery_Detail where DeliveryID='" + myID + "'", clsMySQL.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

                dtpCreditMemoDate.Visible = true;
                txtCreditMemoNo.Visible = true;
                dtpDate.Visible = true;
                txtDate.Visible = false; 

        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (txtCreditMemoNo.Text == "")
            {
                MessageBox.Show("Please enter credit memo number before saving this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else if (dgView.RowCount < 1)
            {
                MessageBox.Show("Please enter credit memo number before saving this record.","Front Desk Module",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);
            }
            else if (MessageBox.Show("This save the record. Do you want to proceed?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                SaveRecord();
            }
        }

        void SaveRecord()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string UnitType = string.Empty;
            string Qty = string.Empty;
            string netAmount = string.Empty;
            string Discount = string.Empty;

            string sSQL1 = "Insert Into Sales_Order_Return(SalesOrderReturnID,DeliveryID,CreditMemoNo,CreditMemoDate,Reason,Referrence,PreparedBy,ReceivedBy,PostedBy,ApprovedBy,Date,AcknowledgedBy,Remarks,Gross,Discount,TaxBase,Vat,NetAmount,CreatedBy,CreatedOn) " +
                           "Values('" + myID + "','" + myID + "','" + txtCreditMemoNo.Text + "','" + dtpCreditMemoDate.Value.ToShortDateString() + "','" + txtReason.Text + "','" + txtReference.Text + "','" + txtPreparedBy.Text + "','" + txtReceivedBy.Text + "','" + txtPostedBy.Text + "','" + txtApprovedBy.Text + "','"
                                   + dtpDate.Value.ToShortDateString() + "','" + txtAcknowledgedBy.Text + "','" + txtRemarks.Text+ "','" + txtGrosse.Text + "','" + txtDiscount.Text + "','" + txtTaxBase.Text+ "','" + txtVAT.Text + "','" + txtNet.Text + "','" + clsVariables.fullname + "','" + DateTime.Now.ToShortDateString() + "')";

            MySqlCommand com = new MySqlCommand(sSQL1, clsMySQL.con);
            com.ExecuteNonQuery();

            for (int n = 0; n < dgView.RowCount; n++)
            {
                ItemNo = dgView.Rows[n].Cells[0].Value.ToString();
                Description = dgView.Rows[n].Cells[1].Value.ToString();
                Qty = dgView.Rows[n].Cells[2].Value.ToString();
                UnitPrice = dgView.Rows[n].Cells[3].Value.ToString();
                Discount = dgView.Rows[n].Cells[5].Value.ToString();
                netAmount = dgView.Rows[n].Cells[6].Value.ToString();

                string sSQL2 = "Insert Into Sales_Order_Return_Details(SalesOrderReturnID,products_id,Qty,Price,Discount) Values ('" + myID +
                                "','" + ItemNo + "','" + Qty + "','" + UnitPrice + "','" + Discount + "')";

                MySqlCommand cmd = new MySqlCommand(sSQL2, clsMySQL.con);
                cmd.ExecuteNonQuery();

                string sSQL3 = "Update Sales_Order_Delivery_Detail set QtyReturned = QtyReturned + " + Qty + " where products_id='" + ItemNo + "'";
                MySqlCommand up = new MySqlCommand(sSQL3, clsMySQL.con);
                up.ExecuteNonQuery();

                MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Sales_Order" + "'", clsMySQL.con);
                pipz.ExecuteNonQuery();
            }

            if (mFormState == "ADD")
            {
                MessageBox.Show("New record has been successfully saved.");
                this.Close();
            }
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {

        }

        private void dgView_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            int n = dgView.CurrentRow.Index;

            txtStockNo.Text = dgView.Rows[n].Cells[0].Value.ToString();
            txtStock.Text = dgView.Rows[n].Cells[1].Value.ToString();
            txtQty.Text = dgView.Rows[n].Cells[2].Value.ToString();
            txtUnitPrice.Text = dgView.Rows[n].Cells[3].Value.ToString();
            txtGross.Text = dgView.Rows[n].Cells[4].Value.ToString();
            txtDisc.Text = dgView.Rows[n].Cells[5].Value.ToString();
            txtNetAmount.Text = dgView.Rows[n].Cells[6].Value.ToString();
        }

  }
}
