﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Mail;
using System.Collections;
using MySql.Data.MySqlClient;

namespace FrontDesk
{
    public partial class frmSendEmail : Form
    {
        ArrayList alAttachments;

        public frmSendEmail()
        {
            InitializeComponent();
        }

        private void newToolStripButton_Click(object sender, EventArgs e)
        {
            string[] arr = txtAttachments.Text.Split(';');
            alAttachments = new ArrayList();
            for (int i = 0; i < arr.Length; i++)
            {
                if (!String.IsNullOrEmpty(arr[i].ToString().Trim()))
                {
                    alAttachments.Add(arr[i].ToString().Trim());
                }
            }

            MessageSent();
        }

        private void frmSendEmail_Load(object sender, EventArgs e)
        {
            txtCc.Text = clsVariables.CcEmail;
            txtTo.Text = clsVariables.ToEmail;
        }

        void MessageSent()
        {
            MailMessage msg = new MailMessage();
            msg.From = new MailAddress(txtCc.Text);
            msg.To.Add(txtTo.Text);
            msg.CC.Add(txtCc.Text);
            msg.Subject = txtSubject.Text;
            msg.Body = txtMessage.Text;
            System.Net.NetworkCredential ma = new System.Net.NetworkCredential(clsVariables.EmailUsername,clsVariables.EmailPassword);
            System.Net.Mail.SmtpClient mailClient = new SmtpClient(clsVariables.EmailProvider,clsVariables.EmailPort);
            mailClient.EnableSsl = true;
            mailClient.UseDefaultCredentials = false;
            mailClient.Credentials = ma;
            mailClient.Send(msg);
            MessageBox.Show("Mail sent Successfully");
        }

        private void fileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    string[] arr = openFileDialog1.FileNames;
                    alAttachments = new ArrayList();
                    txtAttachments.Text = string.Empty;
                    alAttachments.AddRange(arr);

                    foreach (string s in alAttachments)
                    {
                        txtAttachments.Text += s + "; ";
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Error");
                }
            }
        }

        void EmailTemplate(string template)
        {
            MySqlCommand cmd = new MySqlCommand();
            cmd.CommandText = "Select * from emailtemplates where MailType='" + template + "'";
            cmd.Connection = clsMySQL.con;
            MySqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                txtSubject.Text = dr["Subject"].ToString();
                txtMessage.Text = dr["Introduction"].ToString() + "\n\n" + dr["SignOff"].ToString();
            }
            dr.Close();
        }

        private void cboTemplates_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cboTemplates.Text)
            {
                case "BIRTHDAY":
                    EmailTemplate(cboTemplates.Text);
                    break;
                case "OVERDUE":
                    EmailTemplate(cboTemplates.Text);
                    break;

                case "ACCOUNT":
                    EmailTemplate(cboTemplates.Text);
                    break;

                case "CUSTOM":
                    EmailTemplate(cboTemplates.Text);
                    break;
            }
        }
    }
}
