﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class MainForm : Form
    {
        
        static public MainForm Instance;

        public MainForm()
        {
            InitializeComponent();
        }

     

        private void ExitToolsStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult ans = MessageBox.Show("Are you sure you want to exit?", "Stock and Inventory Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            if (ans == DialogResult.Yes)
            {
                this.Close();
            }
            else
            { }

        }
        
        private void CascadeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.Cascade);
           
        }

        private void TileVerticalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileVertical);
        }

        private void TileHorizontalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void ArrangeIconsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LayoutMdi(MdiLayout.ArrangeIcons);
        }

        private void CloseAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            foreach (Form childForm in MdiChildren)
            {
                childForm.Close();
            }
        }

        private void productMasterfileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmMovieList master = new frmMovieList();
            master.MdiParent = this;
            master.WindowState = FormWindowState.Maximized;
            master.Show();
        }

        private void itemCategoryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmRentalCategory rentalcategory = new frmRentalCategory();
            rentalcategory.Show();
        }

        private void loginToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmLogin login = new frmLogin();
            login.ShowDialog();
        }

        private void suppliersToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmSupplier supplier = new frmSupplier();
            supplier.MdiParent = this;
            supplier.WindowState = FormWindowState.Maximized;
            supplier.Show();
        }

        private void cashSalesReturnToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmCashSalesReturn cashsalesreturn = new frmCashSalesReturn();
            cashsalesreturn.WindowState = FormWindowState.Maximized;
            cashsalesreturn.MdiParent = this;
            cashsalesreturn.Show();
        }

        private void cashOrderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmSalesOrder SalesOrder = new frmSalesOrder();
            SalesOrder.WindowState = FormWindowState.Maximized;
            SalesOrder.MdiParent = this;
            SalesOrder.Text = "Sales Order";
            SalesOrder.Show();
        }

        private void purchaseOrderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmPurchaseOrder purchaseorder = new frmPurchaseOrder();
            purchaseorder.MdiParent = this;
            purchaseorder.WindowState = FormWindowState.Maximized;
            purchaseorder.Show();
        }

        private void cmdDelete_Click(object sender, EventArgs e)
        {
            
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmAbout about = new frmAbout();
            about.ShowDialog();
        }

        private void cashSalesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmCashSales CashSales = new frmCashSales();
            CashSales.WindowState = FormWindowState.Maximized;
            CashSales.MdiParent = this;
            CashSales.Show();
        }

        private void salesOrderDeliveryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmSalesOrderDelivery SalesOrderDelivery = new frmSalesOrderDelivery();
            SalesOrderDelivery.MdiParent = this;
            SalesOrderDelivery.WindowState = FormWindowState.Maximized;
            SalesOrderDelivery.Show();
        }

        private void salesOrderReturnToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmSalesOrderReturn SalesOrderReturn = new frmSalesOrderReturn();
            SalesOrderReturn.MdiParent = this;
            SalesOrderReturn.WindowState = FormWindowState.Maximized;
            SalesOrderReturn.Show();
        }

        private void purchaseOrderReturnToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmPurchaseOrderReturn PurchaseOrderReturn = new frmPurchaseOrderReturn();
            PurchaseOrderReturn.MdiParent = this;
            PurchaseOrderReturn.WindowState = FormWindowState.Maximized;
            PurchaseOrderReturn.Show();
        }

        private void receiveItemToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmPurchaseOrderReceive Receive = new frmPurchaseOrderReceive();
            Receive.MdiParent = this;
            Receive.Show();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close(); }
            clsConnection.con.Open();

            StockChecker();
        }

        void StockChecker()
        {
            MySqlCommand cmd = new MySqlCommand("Select * From qrystockmonitoring where EndingInv < 10", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            frmCriticalStockChecker frm = new frmCriticalStockChecker();
            dr.Read();
            if(dr.HasRows)
              {
                    if (MessageBox.Show("Warning: There are out of stock items in you inverntory.\n\n Do you want to see this now?", "Out of stock...", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.Yes)
                    {
                        frm.strChecker = "Critical";
                        frm.MdiParent = this;
                        frm.WindowState = FormWindowState.Maximized;
                        frm.Show();
                    }
                    else
                    { return; }

                }
            dr.Close();
        }

        public void EnableControls()
        {
            transactionsToolStripMenuItem.Enabled = true;
            fileMenu.Enabled = true;
            reportsToolStripMenuItem.Enabled = true;
            toolsMenu.Enabled = true;
            windowsMenu.Enabled = true;
            loginToolStripMenuItem.Enabled = false;
            logoutToolStripMenuItem.Enabled = true;
        }

        public void DisableControls()
        {
            transactionsToolStripMenuItem.Enabled = false;
            fileMenu.Enabled = false;
            reportsToolStripMenuItem.Enabled = false;
            toolsMenu.Enabled = false;
            windowsMenu.Enabled = false;
            loginToolStripMenuItem.Enabled = true;
            logoutToolStripMenuItem.Enabled = false;
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            DialogResult reply = MessageBox.Show("Are you sure you want to exit?",
             "Stock and Inventory Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            if (reply == DialogResult.Yes)
            {
                Application.Exit();
            }
            else
            { e.Cancel = true; }
        }

        private void allClientsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmAllCustomer all = new frmAllCustomer();
            all.WindowState = FormWindowState.Maximized;
            all.MdiParent = this;
            all.Show();
        }

        private void reportsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            StockandInventory.frmReports reports = new StockandInventory.frmReports();
            reports.MdiParent = this;
            reports.WindowState = FormWindowState.Maximized;
            reports.Show();
        }

        private void criticalStockCheckerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmCriticalStockChecker check = new frmCriticalStockChecker();
            check.MdiParent = this;
            check.WindowState = FormWindowState.Maximized;
            check.Show();
        }

        private void copyToolStripButton_Click(object sender, EventArgs e)
        {

        }

        private void printToolStripButton_Click(object sender, EventArgs e)
        {

        }

        private void lvQuick_DoubleClick(object sender, EventArgs e)
        {
            switch(lvQuick.FocusedItem.Index)
            {
                case 0:
                    cashSalesToolStripMenuItem_Click(this, new System.EventArgs());
                    break;

                case 1:
                    cashSalesReturnToolStripMenuItem_Click(this, new System.EventArgs());
                    break;

                case 2:
                    cashOrderToolStripMenuItem_Click(this, new System.EventArgs());
                    break;

                case 3:
                    salesOrderDeliveryToolStripMenuItem_Click(this, new EventArgs());
                    break;

                case 4:
                    salesOrderReturnToolStripMenuItem_Click(this, new EventArgs());
                    break;

                case 5:
                    purchaseOrderToolStripMenuItem_Click(this, new EventArgs());
                    break;

                case 6:
                    frmPurchaseOrderReceive pipo = new frmPurchaseOrderReceive();
                    pipo.MdiParent = this;
                    pipo.WindowState = FormWindowState.Maximized;
                    pipo.Show();
                    break;

                case 7:
                    purchaseOrderReturnToolStripMenuItem_Click(this, new EventArgs());
                    break;

                case 8:
                    allClientsToolStripMenuItem_Click(this, new EventArgs());
                    break;

                case 9:
                    suppliersToolStripMenuItem_Click(this, new EventArgs());
                    break;

                case 10:
                    productMasterfileToolStripMenuItem_Click(this, new EventArgs());
                    break;

                case 11:
                    criticalStockCheckerToolStripMenuItem_Click(this, new EventArgs());
                    break;
            }
        }

    }
}
