﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
 
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmAddMovie : Form
    {
        public string flag,ItemNo;
        public int myID;
 
        public frmAddMovie()
        {
            InitializeComponent();
        }

        private void cmdBrowse_Click(object sender, EventArgs e)
        {
            openFileDialog1.Title = "Select Picture";
            openFileDialog1.Filter = "Image Files (JPEG,GIF,BMP)|*.jpg;*.jpeg;*.gif;*.bmp|JPEG Files(*.jpg;*.jpeg)|*.jpg;*.jpeg|GIF Files(*.gif)|*.gif|BMP Files(*.bmp)|*.bmp";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                String myFileName = openFileDialog1.FileName;
                txtimgLink.Text = myFileName;
                picImage.Image = Image.FromFile(openFileDialog1.FileName);
            }
            openFileDialog1.Dispose();
        }

        private void frmAddMovie_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close();}
            clsConnection.con.Open();
            switch(flag)
            {
            case "Save":
                    RentalCategory();
                    FillRentalCategory();
                    GenerateID();
                    ProductQTYChecker();
                    break;
            case "Update":
                    RentalCategory();
                    FillRentalCategory();
                    ProductQTYChecker();
                    break;
            }
        }

        public void ProductQTYChecker()
        {
            int QTY;
            MySqlCommand com = new MySqlCommand("Select EndingInv From stockinv where products_id='" + ItemNo + "'", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                QTY = int.Parse(dr["EndingInv"].ToString());
                lblStatus.Text = "There is only " + QTY + "item with this";

            }
            dr.Close();
        }
        private void GenerateID()
        {
            try
            {
                MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator where TableName='" + "Products" + "'", clsConnection.con);
                MySqlDataReader dr = cmddr.ExecuteReader();

                while (dr.Read())
                {
                    string strid = dr["NextNo"].ToString();
                    if (strid == "")
                    {
                        this.txtItemNo.Text = "MOV-" + "1";
                        myID = 1;
                    }
                    else
                    {
                        myID = Convert.ToInt32(dr["NextNo"]) + 1;
                        txtItemNo.Text = "MOV-" + myID.ToString();
                    }

                }
                dr.Close();
                cmddr.Dispose();
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
            }
        }

        void RentalCategory()
        {
            MySqlCommand cmd = new MySqlCommand("Select RentalCategory_Name From rentalcategory", clsConnection.con);
            MySqlDataReader dr;

            dr = cmd.ExecuteReader();

            while (dr.Read())
            {
                cboRentCategory.Items.Add(dr["RentalCategory_Name"]);
            }
            dr.Close();
        } 

        void CheckDuplicateRecord()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlDataReader reader;

            com.CommandText = "Select * from products where products_id='" + txtItemNo.Text + "'";
            com.Connection = clsConnection.con;
            com.CommandType = CommandType.Text;
            reader = com.ExecuteReader();
            reader.Read();
            if (reader.HasRows)
            {
                MessageBox.Show("This product is already been added on the record", "Stock and Inventory Module",
                                MessageBoxButtons.OK, MessageBoxIcon.Information);
                reader.Close();
            }
            else
            {
                reader.Close();
                SaveItems();
            }
            
        }

        void SaveItems()
        {
            try
            {
                MySqlCommand cmd = new MySqlCommand();
                MySqlCommand inv = new MySqlCommand();
                MySqlCommand mov = new MySqlCommand();

                cmd.CommandText = "Insert Into products (n_id,products_id,products_Title,Barcode,BegInvStock,Supplier,Genre,Plot,Cast,Director,ProductionYear,Runtime,Rating,Type,Location,SpecialFeatures,ImageLink,IMDBLink,ReleaseDate,RentalCategory,DefaultPrice,RentalDays,LastRented,CostPrice,SellingPrice,State,Format,PurchaseDate) Values('" +
                                    myID + "','" + txtItemNo.Text + "','" + txtTitle.Text + "','" + txtBarcode.Text + "','" + txtQuantity.Text + "','" + txtDistributor.Text + "','" + cboGenre.Text + "','" + txtPlot.Text + "','" + txtCast.Text + "','" + txtDirector.Text + "','"
                                    + txtYear.Text + "','" + txtRuntime.Text + "','" + txtRating.Text + "','" + cboFormat.Text + "','" + txtLocation.Text + "','" + txtSpecialFeatures.Text + "','" + openFileDialog1.FileName + "','" + txtIMDB.Text + "','" + dtpRelease.Value.ToString() + "','" + cboRentCategory.Text + "','"
                                    + txtDefaultPrice.Text + "','" + txtRentalDays.Text + "','" + txtLastRented.Text + "','" + txtCostPrice.Text + "','" + txtSellingPrice.Text + "','" + cboState.Text + "','" + cboFormat.Text + "','" + txtPurchaseDate.Text + "')";
                
                cmd.Connection = clsConnection.con;
                cmd.CommandType = CommandType.Text;
                cmd.ExecuteNonQuery();

                inv.CommandText = "Insert Into stockinv(products_id,BegInvStock,StockInvDate,EndingInv) Values ('" + txtItemNo.Text + "','" + txtQuantity.Text + "','" + DateTime.Now.Date + "','" + txtQuantity.Text + "')";
                inv.Connection = clsConnection.con;
                inv.ExecuteNonQuery();

                mov.CommandText = "Insert Into movie_trailer(products_id,Trailer_Link) Values('" + txtItemNo.Text + "','" + txtTrailer.Text + "')";
                mov.Connection = clsConnection.con;
                mov.ExecuteNonQuery();

                MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Sales_Order" + "'", clsConnection.con);
                pipz.ExecuteNonQuery();


                picBarcode.SaveImage(txtBarcode.Text);                

                MessageBox.Show("Record Successfully Saved...", "Stock and Inventory Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();
                frmMovieList list = new frmMovieList();
                list.FillItemList();
                list.Refresh();
            }
            catch (MySqlException e)
            {
                MessageBox.Show(e.Message, "Stock and Inventory Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (flag == "Update")
            {
                UpdateQRY();
            }
            else
            { CheckDuplicateRecord(); }
        }


        void UpdateQRY()
        {
            MySqlCommand command = new MySqlCommand();
            MySqlCommand inv = new MySqlCommand();
            MySqlCommand mov = new MySqlCommand();


            command.CommandText = "UPDATE products SET products_id ='" + txtItemNo.Text + "',products_Title ='" + txtTitle.Text + "',Barcode='" + txtBarcode.Text + "',Supplier='" + txtDistributor.Text + "',Genre='" + cboGenre.Text +
                                    "',Plot='" + txtPlot.Text + "',Cast='" + txtCast + "',Director ='" + txtDirector.Text + "',ProductionYear ='" + txtYear.Text + "',Runtime ='" + txtRating.Text + "',Rating ='" + txtRating.Text + "',Type ='" + cboFormat.Text + "',Location='" + txtLocation +
                                    "',SpecialFeatures='" + txtSpecialFeatures.Text + "',ImageLink ='" + txtimgLink.Text + "',IMDBLink='" + txtIMDB.Text + "',ReleaseDate='" + dtpRelease.Value.ToString()+"',RentalCategory='" + cboRentCategory.Text + "',DefaultPrice ='" + txtDefaultPrice.Text +
                                    "',RentalDays ='" + txtRentalDays.Text + "',LastRented='" + txtLastRented.Text + "',CostPrice='" + txtCostPrice.Text + "',ImageLink = '" + txtimgLink.Text  + "', SellingPrice='" + txtSellingPrice.Text + "',State='" + cboState.Text + "',Format='" + cboFormat.Text + "',PurchaseDate ='" + txtPurchaseDate.Text + "', BegInvStock='" + txtQuantity.Text + "' Where products_id ='" + txtItemNo.Text + "'";
            command.Connection = clsConnection.con;
            command.ExecuteNonQuery();

            inv.CommandText = "Update movie_trailer Set Trailer_Link ='" + txtTrailer.Text + "' where products_id ='" + txtItemNo.Text + "'";
            inv.Connection = clsConnection.con;
            inv.ExecuteNonQuery();

            picBarcode.SaveImage(txtBarcode.Text);

            MessageBox.Show("Record Successfully Updated...", "Stock and Inventory Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
            this.Close();
        }

        void FillRentalCategory()
        {
            int RentalID;

            MySqlCommand com = new MySqlCommand("Select * from rentalcategory",clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            cboRentCategory.Items.Clear();
            while (dr.Read())
            { 
                cboRentCategory.Items.Add(dr["RentalCategory_Name"].ToString());
                RentalID = int.Parse(dr["RentalCategory_ID"].ToString());
            }
            dr.Close();
        }

        private void txtBarcode_TextChanged(object sender, EventArgs e)
        {
            picBarcode.BarCode = txtBarcode.Text;
        }

        
    }
}