﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmAllCustomer : Form
    {
        public string SearchItem,RentalIDs;

        public frmAllCustomer()
        {
            InitializeComponent();
        }

        private void frmAllCustomer_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                this.Dispose();
            }
        }

        private void frmAllCustomer_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close(); }
            clsConnection.con.Open();
            FillListView();
        }

        public void AddCustomer()
        {
            frmCustomer customer = new frmCustomer();
            customer.mFormState = "ADD";
            customer.ShowDialog();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            AddCustomer();
        }

        private void cmdRefresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        public void FillListView()
        {
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            lvList.Items.Clear();

            cmd.CommandText = "SELECT * FROM Customers";
            cmd.Connection = clsConnection.con;
            dr = cmd.ExecuteReader();

            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["customers_id"].ToString());
                             list.SubItems.Add(dr["FName"].ToString() +" "+ dr["LName"].ToString());
                             list.SubItems.Add(dr["PermanentAddress"].ToString());
                             list.SubItems.Add(dr["EmailAddress"].ToString());
                             list.SubItems.Add(dr["MobileNo"].ToString());
                             lvList.Items.AddRange(new ListViewItem[] { list });
                             list.ImageIndex = 1;
                             
            }
            dr.Close();
        }

        public void SearchQRY(string SearchItems)
        {
            MySqlCommand mysqlcommand = new MySqlCommand();
            MySqlDataReader reader;

            mysqlcommand.CommandText = "Select tblCustomer.* From tblCustomer Where CustomerID='" + SearchItems + "'";
            mysqlcommand.Connection = clsConnection.con;
            mysqlcommand.CommandType = CommandType.Text;
            reader = mysqlcommand.ExecuteReader();

            while (reader.Read())
            {
                ListViewItem list = new ListViewItem(reader["CustomerID"].ToString());
                list.SubItems.Add(reader["FName"].ToString() + " " + reader["MI"].ToString() + ". " + reader["LName"].ToString());
                list.SubItems.Add(reader["Address"].ToString());
                list.SubItems.Add(reader["EmailAddress"].ToString());
                list.SubItems.Add(reader["Cellphone"].ToString());
                lvList.Items.AddRange(new ListViewItem[] { list });
            }
            reader.Close();
        }


        public void DeleteQRY(string Items)
        {
                DialogResult msg = MessageBox.Show("Are you sure you want to remove this?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (msg == DialogResult.Yes)
                {
                    MySqlCommand cmds = new MySqlCommand();
                    cmds.CommandText = "DELETE FROM customers where customers_id='" + Items + "'";
                    cmds.Connection = clsConnection.con;
                    cmds.ExecuteNonQuery();
                    MessageBox.Show("Record Successfully Deleted!!!", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    FillListView();
                }
                else
                { }

        }


       public void ModifyCustomer()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlDataReader read;

            //try
            //{
                frmCustomer frm = null;
                foreach (Form f in this.MdiChildren)
                {
                    if (f is frmCustomer)
                    {
                        frm = (frmCustomer)f;
                        break;
                    }
                }
                if (frm == null)
                {
                    frm = new frmCustomer();
                    frm.mFormState = "EDIT";
                    //frm.MdiParent = MainForm.ActiveForm;
                }
                com.CommandText = "Select * from customers where customers_id='" + lvList.FocusedItem.Text + "'";
                com.Connection = clsConnection.con;
                read = com.ExecuteReader();
                while (read.Read())
                {
                    frm.mFormState = "EDIT";

                    frm.txtCustomerNo.Text =read["customers_id"].ToString();
                    frm.txtFName.Text = read["FName"].ToString();
                    frm.txtLastName.Text = read["LName"].ToString();
                    frm.txtMI.Text = read["MI"].ToString();
                    frm.txtMobileNo.Text = read["MobileNo"].ToString();
                    frm.txtAddress.Text = read["PermanentAddress"].ToString();
                    frm.txtMailingAddress.Text = read["MailingAddress"].ToString();
                    frm.txtEmail.Text = read["EmailAddress"].ToString();
                    //frm.dtpDOB.Text= read["DOB"].ToString();
                    frm.cboGender.Text = read["Gender"].ToString();
                    frm.txtUserName.Text = read["UserName"].ToString();
                    frm.txtPassword.Text = read["Password"].ToString();
                    frm.cboRentalPlan.Text = read["RentalCategory_Name"].ToString();
                }
                read.Close();
                //com.Dispose();

                frm.Focus();
                frm.Show();
            //}
           // catch (Exception ex) { MessageBox.Show(ex.ToString()); }
        }

       private void modifyEntryToolStripMenuItem_Click(object sender, EventArgs e)
       {
           ModifyCustomer();
       }

       private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
       {
           DeleteQRY(lvList.FocusedItem.Text);
       }

       private void btn_Edit_Click(object sender, EventArgs e)
       {
           ModifyCustomer();
       }

       private void btn_close_Click(object sender, EventArgs e)
       {
           this.Dispose();
       }

       private void lvList_SelectedIndexChanged(object sender, EventArgs e)
       {         
           SearchItem = lvList.FocusedItem.Text;
       }

       private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
       {

       }

    }
}
