﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;
using Microsoft.Office.Interop.Excel;
using Microsoft.VisualBasic;
using Microsoft.VisualBasic.Compatibility;

namespace StockandInventory_Module
{
    public partial class frmCashSales : Form
    {
        public frmCashSales()
        {
            InitializeComponent();
        }

        private void frmCashSales_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close(); }
            clsConnection.con.Open();

            FillListView();
            CalculateSale();

        }

        void CalculateSale()
        {
            MySqlCommand com = new MySqlCommand("Select SUM(Gross) as TotalGross From Cash_Sales", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtTotalCashSales.Text = dr["TotalGross"].ToString();
            }
            dr.Close();
        }

        void AutoCompleteSoldTo()
        {
            MySqlCommand com = new MySqlCommand("Select Fullname from qryfullname", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtSearch.AutoCompleteCustomSource.Add(dr["Fullname"].ToString());
            }
            dr.Close();
        }

        void AutoCompleteInvoiceNo()
        {
            MySqlCommand com = new MySqlCommand("Select InvoiceNo from cash_sales", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtSearch.AutoCompleteCustomSource.Add(dr["InvoiceNo"].ToString());
            }
            dr.Close();
        }

        
        void FillListView()
        {
            MySqlCommand cmd = new MySqlCommand("Select * From Cash_Sales",clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            listView1.Items.Clear();
            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["Date"].ToString());
                    list.SubItems.Add(dr["InvoiceNo"].ToString());
                    list.SubItems.Add(dr["SoldTo"].ToString());
                    list.SubItems.Add(dr["BusinessName"].ToString());
                    list.SubItems.Add(dr["Address"].ToString());
                    list.SubItems.Add(dr["Gross"].ToString());
                    list.SubItems.Add(dr["Discount"].ToString());
                    list.SubItems.Add(dr["NetAmount"].ToString());
                    list.SubItems.Add(dr["CashSalesID"].ToString());
                    list.ImageIndex = 0;
                    listView1.Items.AddRange(new ListViewItem[] { list });
            }
            dr.Close();
        }

        void FillLastname()
        {
            MySqlCommand cmd = new MySqlCommand("Select * From Cash_Sales where SoldTo Like '%" + txtSearch.Text + "%'", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            listView1.Items.Clear();
            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["Date"].ToString());
                list.SubItems.Add(dr["InvoiceNo"].ToString());
                list.SubItems.Add(dr["SoldTo"].ToString());
                list.SubItems.Add(dr["BusinessName"].ToString());
                list.SubItems.Add(dr["Address"].ToString());
                list.SubItems.Add(dr["Gross"].ToString());
                list.SubItems.Add(dr["Discount"].ToString());
                list.SubItems.Add(dr["NetAmount"].ToString());
                list.SubItems.Add(dr["CashSalesID"].ToString());
                list.ImageIndex = 0;
                listView1.Items.AddRange(new ListViewItem[] { list });
            }
            dr.Close();
        }

        void FillInvoiceNo()
        {
            MySqlCommand cmd = new MySqlCommand("Select * From Cash_Sales where InvoiceNo LIKE '%" + txtSearch.Text + "%'", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            listView1.Items.Clear();
            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["Date"].ToString());
                list.SubItems.Add(dr["InvoiceNo"].ToString());
                list.SubItems.Add(dr["SoldTo"].ToString());
                list.SubItems.Add(dr["BusinessName"].ToString());
                list.SubItems.Add(dr["Address"].ToString());
                list.SubItems.Add(dr["Gross"].ToString());
                list.SubItems.Add(dr["Discount"].ToString());
                list.SubItems.Add(dr["NetAmount"].ToString());
                list.SubItems.Add(dr["CashSalesID"].ToString());
                list.ImageIndex = 0;
                listView1.Items.AddRange(new ListViewItem[] { list });
            }
            dr.Close();
        }

        private void cmdRefresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        private void txtSearch_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            { 
                cmdSearch_Click(this, new System.EventArgs());
            }
        }

        private void cboField_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (cboField.Text)
            { 
                case "Lastname":
                    AutoCompleteSoldTo();
                    break;
                case "Invoice No":
                    AutoCompleteInvoiceNo();
                    break;
            }
        }

        private void cmdSearch_Click(object sender, EventArgs e)
        {
            switch (cboField.Text)
            {
                case "Lastname":
                    FillLastname();
                    break;
                case "Invoice No":
                    FillInvoiceNo();
                    break;
           }
        }


        private void btn_Edit_Click(object sender, EventArgs e)
        {

        }

        private void btn_close_Click(object sender, EventArgs e)
        {
            frmGraphInventory graph = new frmGraphInventory();
            graph.Show();
        }

        private void btn_Excel_Click(object sender, EventArgs e)
        {
            Microsoft.Office.Interop.Excel.Application xla = new Microsoft.Office.Interop.Excel.Application();
            xla.Visible = true;
            Workbook wb = xla.Workbooks.Add(XlSheetType.xlWorksheet);
            Worksheet ws = (Worksheet)xla.ActiveSheet;
            int i = 1;
            int j = 1;
            foreach (ListViewItem comp in listView1.Items)
            {
                ws.Cells[i, j] = comp.Text.ToString();
                //MessageBox.Show(comp.Text.ToString());
                foreach (ListViewItem.ListViewSubItem drv in comp.SubItems)
                {
                    ws.Cells[i, j] = drv.Text.ToString();
                    j++;
                }
                j = 1;
                i++;
            }
        }



    }
}
