﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
 
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmMovieList : Form
    {
        public frmMovieList()
        {
            InitializeComponent();
        }

        public void FillItemList()
        {
            int Qty;
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            lvList.Items.Clear();

            cmd.CommandType = CommandType.Text;
            cmd.CommandText = "Select * from qrystockmonitoring";
            cmd.Connection = clsConnection.con;
            dr = cmd.ExecuteReader();
              while (dr.Read())
                {
                    ListViewItem list = new ListViewItem(dr["products_id"].ToString());
                    list.SubItems.Add(dr["Barcode"].ToString());
                    list.SubItems.Add(dr["products_Title"].ToString());
                    list.SubItems.Add(dr["RentalCategory"].ToString());
                    list.SubItems.Add(dr["Genre"].ToString());
                    list.SubItems.Add(dr["BegInvStock"].ToString());
                    list.SubItems.Add(dr["SellingPrice"].ToString());
                    list.SubItems.Add(dr["EndingInv"].ToString());

                    Qty = Convert.ToInt32(dr["EndingInv"]);

                    if (Qty < 10)
                    {
                       list.BackColor = Color.Red;
                    }
                    else
                    { }
                    lvList.Items.AddRange(new ListViewItem[] { list });
                    list.ImageIndex = 0;
            }
            dr.Close();
        }
        
        private void cmdAdd_Click(object sender, EventArgs e)
        {
            frmAddMovie addmovie = new frmAddMovie();
            addmovie.flag = "Save";
            addmovie.Show();
        }

        private void frmMovieList_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close();}
            clsConnection.con.Open();

            
            FillItemList();
        }

        private void cmdRefresh_Click(object sender, EventArgs e)
        {
            FillItemList();
            this.Refresh();
        }

        private void cmdDelete_Click(object sender, EventArgs e)
        {
            DialogResult reply = MessageBox.Show("Are you sure you want to delete this record?",
              "Stock and Inventory Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            if (reply == DialogResult.Yes)
            {
                if (lvList.SelectedItems.Count < 1)
                {
                    MessageBox.Show("Please select items to delete.");
                }
                else
                { DeleteRecord(lvList.FocusedItem.Text); }
            }
            else
            {}

        }

        void DeleteRecord(String Items)
        {
            MySqlCommand com = new MySqlCommand();
            com.CommandText = "Delete From products where products_id='" + Items.ToString() +"'";
            com.CommandType = CommandType.Text;
            com.Connection = clsConnection.con;
            com.ExecuteNonQuery();

            MessageBox.Show("Record successfully deleted","Stock and Inventory Module",MessageBoxButtons.OK, MessageBoxIcon.Information);
            FillItemList();
        }

        void SearchQRY()
        {
            MySqlCommand search = new MySqlCommand();
            MySqlDataReader dr;

            lvList.Items.Clear();

            search.CommandText = "SELECT * FROM qrystockmonitoring WHERE " + cboField.Text + " ='" + txtSearch.Text + "'";
            search.Connection = clsConnection.con;
            dr = search.ExecuteReader();

            while (dr.Read())
            {
                ListViewItem list = new ListViewItem(dr["products_id"].ToString());
                list.SubItems.Add(dr["Barcode"].ToString());
                list.SubItems.Add(dr["products_Title"].ToString());
                list.SubItems.Add(dr["RentalCategory"].ToString());
                list.SubItems.Add(dr["Genre"].ToString());
                list.SubItems.Add(dr["BegInvStock"].ToString());
                list.SubItems.Add(dr["SellingPrice"].ToString());
                list.SubItems.Add(dr["EndingInv"].ToString());
                lvList.Items.AddRange(new ListViewItem[] { list });
                list.ImageIndex = 0;
            }
            dr.Close();

        }

        private void cmdEdit_Click(object sender, EventArgs e)
        {
          MySqlCommand com;
          MySqlDataReader dr;
         //try 
         // {
                frmAddMovie frm = null;
                foreach (Form f in this.MdiChildren)
                {
                    if (f is frmAddMovie)
                    {
                        frm = (frmAddMovie)f;
                        break;
                    }
                }

                if (frm == null)
                {
                    frm = new frmAddMovie();
                    frm.flag = "Update";
                }
                com = new MySqlCommand("Select * from products where products_id='" + lvList.FocusedItem.Text + "'", clsConnection.con);
                dr = com.ExecuteReader();
                while (dr.Read())
                {
                    frm.txtItemNo.Text = dr["products_id"].ToString();
                    frm.ItemNo = lvList.FocusedItem.Text;
                    frm.txtBarcode.Text = dr["Barcode"].ToString();
                    frm.txtTitle.Text = dr["products_Title"].ToString();
                    frm.txtQuantity.Text = dr["BegInvStock"].ToString();
                    frm.txtDistributor.Text = dr["Supplier"].ToString();
                    frm.cboGenre.Text = dr["Genre"].ToString();
                    frm.txtPlot.Text = dr["Plot"].ToString();
                    frm.txtCast.Text = dr["Cast"].ToString();
                    frm.txtDirector.Text = dr["Director"].ToString();
                    frm.txtDefaultPrice.Text = dr["DefaultPrice"].ToString();
                    frm.txtIMDB.Text = dr["IMDBLink"].ToString();
                    frm.txtimgLink.Text = dr["ImageLink"].ToString();
                    frm.txtLastRented.Text = dr["LastRented"].ToString();
                    frm.dtpRelease.Value = Convert.ToDateTime(dr["ReleaseDate"].ToString());
                    frm.txtLocation.Text = dr["Location"].ToString();
                    frm.txtPurchaseDate.Text = dr["PurchaseDate"].ToString();
                    frm.txtRating.Text = dr["Rating"].ToString();
                    frm.txtRentalDays.Text = dr["RentalDays"].ToString();
                    frm.txtRuntime.Text = dr["Runtime"].ToString();
                    frm.txtSellingPrice.Text = dr["SellingPrice"].ToString();
                    frm.txtSpecialFeatures.Text = dr["SpecialFeatures"].ToString();
                    frm.txtYear.Text = dr["ProductionYear"].ToString();
                    frm.cboState.Text = dr["State"].ToString();
                    frm.cboGenre.Text = dr["Genre"].ToString();
                    frm.cboFormat.Text = dr["Format"].ToString();
                    frm.cboRentCategory.Text = dr["RentalCategory"].ToString();
                    frm.txtCostPrice.Text = dr["CostPrice"].ToString();
                    //frm.picImage.Image = Image.FromFile(frm.txtimgLink.Text);
                }
                dr.Close();
                com.Dispose();

                com.CommandText = "Select * from movie_trailer where products_id='" + lvList.FocusedItem.Text + "'";
                com.Connection = clsConnection.con;
                dr = com.ExecuteReader();
                while (dr.Read())
                {
                    frm.txtTrailer.Text = dr["Trailer_Link"].ToString();
                }
                dr.Close();
                com.Dispose();

                frm.flag = "Update";
                frm.Focus();
                frm.Show();
            //}
            //catch (Exception ex) { MessageBox.Show(ex.ToString()); }
        }

        private void cmdSearch_Click(object sender, EventArgs e)
        {
            SearchQRY();
        }

        private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void btn_close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

  }
}
