﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.ReportSource;
using CrystalDecisions.Shared;
using CrystalDecisions.Windows.Forms;
using CRAXDRT;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmPrintPreview : Form
    {
        public string strReport = String.Empty;
        public string PK = String.Empty;
        public string strYear = String.Empty;
        public bool blnPaid = false;
        public string strWhere = String.Empty;

        CRAXDRT.Application mTest = null;
        CRAXDRT.Report mReport = null;
        CRAXDRT.Report SubReport = null;
        CRAXDRT.ParameterFieldDefinitions mParam = null;

        public frmPrintPreview()
        {
            InitializeComponent();
        }

        private void frmPrintPreview_Load(object sender, EventArgs e)
        {
            object mSubRep = null;
            try
            {
                mTest = new CRAXDRT.Application();
                mReport = new CRAXDRT.Report();

                switch (strReport)
                {
                    case "Sales Order":
                        mReport = mTest.OpenReport(Environment.CurrentDirectory + "\\Reports\\rptSalesOrder.rpt", null);

                        mReport.RecordSelectionFormula = strWhere;
                        break;

                    case "Purchase Order":
                        mReport = mTest.OpenReport(Environment.CurrentDirectory + "\\Reports\\rptPurchaseOrder.rpt", null);

                        mReport.RecordSelectionFormula = strWhere;
                        break;
                    case "Receiving Report":
                        mReport = mTest.OpenReport(Environment.CurrentDirectory + "\\Reports\\rptReceivingReport.rpt", null);

                        mReport.RecordSelectionFormula = strWhere;
                        break;
                    case "Purchase Order Return":
                        mReport = mTest.OpenReport(Environment.CurrentDirectory + "\\Reports\\rptPurchaseOrderReturn.rpt", null);

                        mReport.RecordSelectionFormula = strWhere;
                        break;
                }
                CRViewer.ReportSource = mReport;
                CRViewer.ViewReport();
            }
            catch(MySqlException ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
