﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmPurchaseOrder : Form
    {
        public frmPurchaseOrder()
        {
            InitializeComponent();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            frmPurchaseOrderAE purchase = new frmPurchaseOrderAE();
            purchase.mFormState = "ADD";
            purchase.ShowDialog();
        }

        private void btn_close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btn_Edit_Click(object sender, EventArgs e)
        {
            frmPurchaseOrderAE edit = new frmPurchaseOrderAE();
            edit.mFormState = "EDIT";
            edit.myID = Convert.ToInt32(lvList.Items[lvList.FocusedItem.Index].SubItems[7].Text);
            edit.Show();
        }

        private void frmPurchaseOrder_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close(); }
            clsConnection.con.Open();
            FillListView();
        }

        void FillListView()
        {
            MySqlCommand com = new MySqlCommand("Select PONo, Description, Date, Salesman, QtyOrdered, QtyRcvd, QtyDue, PurchaseOrderID From qry_Purchase_Order Order By Date DESC", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            lvList.Items.Clear();
            while (dr.Read())
            {
                ListViewItem lv = new ListViewItem(dr["PONo"].ToString());
                lv.SubItems.Add(dr["Description"].ToString());
                lv.SubItems.Add(dr["Date"].ToString());
                lv.SubItems.Add(dr["Salesman"].ToString());
                lv.SubItems.Add(dr["QtyOrdered"].ToString());
                lv.SubItems.Add(dr["QtyRcvd"].ToString());
                lv.SubItems.Add(dr["QtyDue"].ToString());
                lv.SubItems.Add(dr["PurchaseOrderID"].ToString());
                lvList.Items.AddRange(new ListViewItem[] { lv });
                lv.ImageIndex = 0;
            }
            dr.Close();
        }

        private void btn_Refresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        private void btn_Delete_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to void the selected record?\n\n WARNING: You cannot undo this operation.This will permanently remove the record.", "Confirm Record", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                MySqlCommand command = new MySqlCommand("DELETE FROM Purchase_Order WHERE PONo ='" + lvList.FocusedItem.Text + "'", clsConnection.con);
                command.ExecuteNonQuery();

                MessageBox.Show("Record has been successfully removed.");
            }
        }

        private void lvList_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            { 
                btn_Delete_Click(this, new System.EventArgs());
            }
        }

    }
}
