﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;
using CrystalDecisions.Shared;
using CrystalDecisions.CrystalReports.Engine;

namespace StockandInventory_Module
{
    public partial class frmPurchaseOrderAE : Form
    {
        public int myID;
        public string mFormState;

        public frmPurchaseOrderAE()
        {
            InitializeComponent();
        }

        private void frmPurchaseOrderAE_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close(); }
            clsConnection.con.Open();

            switch (mFormState)
            {
                case "ADD":
                    GenerateID();
                    AutoCompleteStockID();
                    AutoCompleteSupplier();

                    dtpDate.Value = DateTime.Now;
                    this.Text = "Create New Entry";
                    cmdModificationHistory.Enabled = false;
                    break;

                case "EDIT":
                    AutoCompleteStockID();
                    AutoCompleteSupplier();

                    cmdPrintPreview.Visible = true;
                    cmdCancel.Text = "Close";
                    cmdModificationHistory.Enabled = true;

                    DisplayForViewing();

                    break;
            }
        }

        void AutoCompleteStockID()
        {
            MySqlCommand cmd = new MySqlCommand("Select * From products ", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                txtStock.AutoCompleteCustomSource.Add(dr["products_Title"].ToString());
            }
            dr.Close();
        }

        void AutoCompleteSupplier()
        {
            MySqlCommand cmd = new MySqlCommand("Select Description From Suppliers Order By Supplier_ID", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                nsdVendor.AutoCompleteCustomSource.Add(dr["Description"].ToString());
            }
            dr.Close();
        }

        private void GenerateID()
        {
            MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator Where TableName='" + "Purchase_Order" + "'" , clsConnection.con);
            MySqlDataReader dr = cmddr.ExecuteReader();

            while (dr.Read())
            {
                string strid = dr["NextNo"].ToString();
                if (strid == "")
                {
                    txtPONo.Text = "PO-" + "1";
                    myID = 1;
                }
                else
                {
                    myID = Convert.ToInt32(dr["NextNo"]) + 1;
                    txtPONo.Text = "PO-" + myID.ToString();
                }

            }
            dr.Close();
            cmddr.Dispose();
        }

        void SearchItem(string ItemNo)
        {
            decimal UnitPrice;

            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            cmd.CommandText = "Select * From products where products_Title Like '%" + ItemNo.Trim() + "%'";
            cmd.Connection = clsConnection.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                txtStockNo.Text = (String)dr["products_id"].ToString();
                txtStock.Text = (String)dr["products_Title"].ToString();
                UnitPrice = Convert.ToDecimal(dr["SellingPrice"].ToString());
                txtUnitPrice.Text = String.Format("{0:0.##}", UnitPrice);
            }
            dr.Close();
        }

       
        void DisplayForViewing()
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Purchase_Order WHERE PurchaseOrderID=" + myID + "", clsConnection.con);
            MySqlDataReader rs = cmd.ExecuteReader();
            while (rs.Read())
            {
                nsdVendor.Text = rs["Description"].ToString();
                txtPONo.Text = rs["PONo"].ToString();
                txtAddress.Text = rs["City_Town"].ToString() + ", " + rs["Province"].ToString() + " " + rs["ZipCode"].ToString();
                txtDate.Text = rs["Date"].ToString();
                txtSalesman.Text = rs["Salesman"].ToString();

                txtGrosse.Text = rs["Gross"].ToString();
                txtDiscount.Text = rs["Discount"].ToString();
                txtTaxBase.Text = rs["TaxBase"].ToString();
                txtVAT.Text = rs["Vat"].ToString();
                txtNet.Text = rs["NetAmount"].ToString();
                txtRemarks.Text = rs["Remarks"].ToString();

                txtShippingInstructions.Text = rs["ShippingInstructions"].ToString();
                txtAdditionalInstructions.Text = rs["AdditionalInstructions"].ToString();
                txtDeclaredAs.Text = rs["DeclaredAs"].ToString();
                txtDeclaredValue.Text = rs["DeclaredValue"].ToString();
            }
            rs.Close();

            MySqlCommand com = new MySqlCommand("Select * From qry_Purchase_Order_Detail where PurchaseOrderID='" + myID + "'", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

            dtpDate.Visible = true;
            txtDate.Visible = false;
            picPurchase.Visible = false;
            cmdSave.Visible = false;
            cmdAdd.Visible = false;

            CmdReceiveItem.Left = cmdSave.Left;
            CmdReceiveItem.Visible = true;
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (nsdVendor.Text == "")
            {
                MessageBox.Show("Please select a vendor.");
            }
            if (dgView.RowCount < 0)
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.", "Stock and Inventory", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            if (MessageBox.Show("This save the record. Do you want to proceed?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                SavePurchaseOrder();
            }
        }

        void SavePurchaseOrder()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string UnitType = string.Empty;
            string Qty = string.Empty;
            string netAmount = string.Empty;
            string Discount = string.Empty;

            MySqlCommand Purchase_Order = new MySqlCommand();
            MySqlCommand Purchase_Order_Details = new MySqlCommand();

            Purchase_Order.CommandText = "Insert Into Purchase_Order(PurchaseOrderID,CreatedBy,CreatedOn,supplier_id,PONo,Date,Salesman,ShippingInstructions,AdditionalInstructions,DeclaredAs,DeclaredValue,Gross,Discount,TaxBase,Vat,NetAmount,Remarks) " +
                                      "Values ('" + myID + "','" + clsFunctions.fullname + "','" + DateTime.Now.Date.ToShortDateString() + "','" + txtSupplierID.Text + "','" + txtPONo.Text + "','" + dtpDate.Value.ToShortDateString() + "','" + txtSalesman.Text +
                                      "','" + txtShippingInstructions.Text + "','" + txtAdditionalInstructions.Text + "','" + txtDeclaredAs.Text + "','" + txtDeclaredValue.Text + "','" + txtGrosse.Text + "','" + txtDiscount.Text + "','" + txtTaxBase.Text + "','" + txtVAT.Text + "','" + txtNet.Text + "','" + txtRemarks.Text + "')";
            Purchase_Order.Connection = clsConnection.con;
            Purchase_Order.ExecuteNonQuery();

            MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Sales_Order" + "'", clsConnection.con);
            pipz.ExecuteNonQuery();


            for (int n = 0; n < dgView.RowCount; n++)
            {
                ItemNo = dgView.Rows[n].Cells[0].Value.ToString();
                Description = dgView.Rows[n].Cells[1].Value.ToString();
                Qty = dgView.Rows[n].Cells[2].Value.ToString();
                UnitPrice = dgView.Rows[n].Cells[3].Value.ToString();
                Discount = dgView.Rows[n].Cells[5].Value.ToString();
                netAmount = dgView.Rows[n].Cells[6].Value.ToString();

                Purchase_Order_Details.CommandText = "Insert Into Purchase_Order_Detail(PurchaseOrderID,products_id,Qty,Price,Discount,CreatedBy,CreatedOn) " +
                                                    "Values('" + myID + "','" + ItemNo + "','" + Qty + "','" + UnitPrice + "','" + Discount + "','" + clsFunctions.fullname + "','" + DateTime.Now.ToShortDateString() + "')";
                Purchase_Order_Details.Connection = clsConnection.con;
                Purchase_Order_Details.ExecuteNonQuery();

            }

            if (mFormState == "ADD")
            {
                MessageBox.Show("New record has been successfully saved.");
                this.Close();
            }
            else
            {
                MessageBox.Show("Changes in record has been successfully saved.");
                this.Close();
            }
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            if (txtStock.Text == "")
            { txtStock.Focus(); }

            else if (Convert.ToDouble(txtUnitPrice.Text) <= 0)
            { MessageBox.Show("Please enter a valid sales price.", "Stock and Inventory Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); txtUnitPrice.Focus(); }
            else
            {
                for (int row = 0; row < dgView.Rows.Count; row++)
                {
                    for (int col = 0; col < dgView.Columns.Count; col++)
                    {
                        if (dgView.Rows[row].Cells[col].Value != null &&
                          dgView.Rows[row].Cells[col].Value.Equals(txtStock.Text))
                        {
                            MessageBox.Show("Item Already Exist...");
                            return;
                        }
                    }
                }
                int CurrRow = dgView.Rows.Add();

                dgView.Rows[CurrRow].Cells[0].Value = txtStockNo.Text;
                dgView.Rows[CurrRow].Cells[1].Value = txtStock.Text;
                dgView.Rows[CurrRow].Cells[2].Value = txtQty.Text;
                dgView.Rows[CurrRow].Cells[3].Value = txtUnitPrice.Text;
                dgView.Rows[CurrRow].Cells[4].Value = txtGross.Text;
                dgView.Rows[CurrRow].Cells[5].Value = txtDisc.Text;
                dgView.Rows[CurrRow].Cells[6].Value = txtNetAmount.Text;

                dgView.FirstDisplayedScrollingRowIndex = CurrRow;
                dgView.CurrentCell = dgView.Rows[CurrRow].Cells[0];
                dgView.Rows[CurrRow].Selected = true;

                Clear();
                CalculateTotalPrice();
            }
        }

        void Clear()
        {
            txtStockNo.Text = "";
            txtStock.Text = "";
            txtQty.Text = "1";
            txtUnitPrice.Text = "";
            txtGross.Text = "0";
            txtDisc.Text = "";
            txtNetAmount.Text = "";
        }

        void CalculateTotalPrice()
        {
            //Initial Amount
            decimal tGross = 0;
            decimal tNet = 0;
            decimal tAX = 0;
            decimal tVat = 0;
            //Quantity
            int Quan = 0;
            int Quant = 0;
            int Quanti = 0;
            //Discount
            decimal cDAmount = 0;
            decimal price = 0;

            int i = dgView.RowCount;

            for (int a = 0; a < i; a++)
            {
                try
                {
                    //Initial Total of items in list
                    tGross += decimal.Parse(dgView.Rows[a].Cells[4].Value.ToString());
                    tNet += decimal.Parse(dgView.Rows[a].Cells[6].Value.ToString());
                    //Total Quantity of items in list
                    Quan += int.Parse(dgView.Rows[a].Cells[2].Value.ToString());
                    //Total Price
                    price += decimal.Parse(dgView.Rows[a].Cells[3].Value.ToString());
                    //Total Discount of items in list
                    cDAmount = cDAmount + Convert.ToDecimal((Convert.ToDecimal(dgView.Rows[a].Cells[5].Value.ToString()) / 100) * (Convert.ToDecimal(Quan) * Convert.ToDecimal(price)));
                }
                catch (Exception)
                {
                }
            }
            Quanti = Quant + Quan;
            tAX = (tNet/ 1.12m);
            tVat = tNet - Convert.ToDecimal(tAX);

            txtDiscount.Text = cDAmount.ToString();

            txtGrosse.Text = String.Format("{0:0.##}", tGross);
            txtNet.Text = String.Format("{0:0.##}", tNet);
            txtTaxBase.Text = String.Format("{0:0.##}",tAX);
            txtVAT.Text = String.Format("{0:0.##}", tVat);
        }

        private void dgView_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            {
                if (dgView.SelectedRows.Count > 0)
                {
                    dgView.Rows.RemoveAt(dgView.SelectedRows[0].Index);
                }
                else
                {
                    MessageBox.Show("Select one item to remove!");
                }
            }
        }

        private void CmdReceiveItem_Click(object sender, EventArgs e)
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Purchase_Order_Detail WHERE PurchaseOrderID=" + myID + " AND QtyDue > 0 ORDER BY products_id ASC", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                frmPurchaseOrderReceiveAE deliver = new frmPurchaseOrderReceiveAE();
                deliver.mFormState = "ADD";
                deliver.myID = myID;
                deliver.ShowDialog();
            }
            else
            {
                dr.Close();
                MessageBox.Show("All items are already received.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            dr.Close();
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void txtQty_TextChanged(object sender, EventArgs e)
        {
            decimal Total;
            decimal sum = 0;

            if (txtQty.Text.Equals("") || txtDisc.Text.Equals(""))
            {
                txtNetAmount.Text = "0.00";
            }
            else
            {
                int quantity = int.Parse(txtQty.Text);
                decimal unitprice = decimal.Parse(txtUnitPrice.Text);
                decimal discount = decimal.Parse(txtDisc.Text);


                Total = decimal.Parse(txtUnitPrice.Text) * decimal.Parse(txtQty.Text);
                txtGross.Text = String.Format("{0:0.##}", Total.ToString());

                sum = Convert.ToDecimal(Total - ((discount / 100) * Total));
                txtNetAmount.Text = sum.ToString();

            }


        }

        private void txtStock_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                SearchItem(txtStock.Text);
                txtQty.Text = "1";
                txtDisc.Text = "0";
                txtQty_TextChanged(this, new System.EventArgs());
            }
        }

        private void nsdVendor_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                Supplier(nsdVendor.Text);
            }
        }

        void Supplier(string sID)
        {
            MySqlCommand com = new MySqlCommand("Select Supplier_ID,Description, CONCAT( City_Town,', ', Province,  ' ', ZipCode, '.' ) AS Address From Suppliers where Description Like '%" + sID + "%'", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtSupplierID.Text = dr["Supplier_ID"].ToString();
                txtAddress.Text = dr["Address"].ToString();
            }
            dr.Close();
        }

        private void cmdPrintPreview_Click(object sender, EventArgs e)
        {
            frmPrintPreview print = new frmPrintPreview();
            print.WindowState = FormWindowState.Maximized;
            print.strReport = "Purchase Order";
            print.strWhere = "{Purchase_Order.PurchaseOrderID} =" + myID;
            print.Show();
        }
    }
}