﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmPurchaseOrderReceiveAE : Form
    {
        public int myID, AutoID;
        public string mFormState;

        decimal cIGross, cIAmount, cDAmount;

        public frmPurchaseOrderReceiveAE()
        {
            InitializeComponent();
        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        void ItemAutoComplete()
        {
            MySqlCommand com = new MySqlCommand("Select products_Title,products_id From products", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtStock.AutoCompleteCustomSource.Add(dr["products_Title"].ToString());
            }
            dr.Close();
        }

        private void GenerateDeliveryNo()
        {
            MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator Where TableName='" + "Purchase_Order_Receive" + "'", clsConnection.con);
            MySqlDataReader dr = cmddr.ExecuteReader();
            while (dr.Read())
            {
                string strid = dr["NextNo"].ToString();
                if (strid == "")
                {
                    txtPONo.Text = "POR-" + "1";
                    AutoID = 1;
                }
                else
                {
                    AutoID = Convert.ToInt32(dr["NextNo"]) + 1;
                    txtPONo.Text = "POR-" + AutoID.ToString();
                }
            }
            dr.Close();
            cmddr.Dispose();
        }


        private void frmPurchaseOrderReceiveAE_Load(object sender, EventArgs e)
        {
            if (clsConnection.con.State == ConnectionState.Open)
            { clsConnection.con.Close(); }
            clsConnection.con.Open();

            switch (mFormState)
            {
                case "ADD":

                    cmdPrintPreview.Visible = false;
                    dtpInvoiceDate.Value = DateTime.Now;
                    dtpDeliveryDate.Value = DateTime.Now;
                    this.Text = "Create New Entry";
                    cmdModificationHistory.Enabled = false;
                    GenerateDeliveryNo();

                    ItemAutoComplete();

                    DisplayForEditing();
                    break;
                case "EDIT":
                    ItemAutoComplete();
                    DisplayForViewing();

                    cmdPrintPreview.Visible = true;
                    cmdCancel.Text = "Close";
                    break;
            }
        }

        public void DisplayForEditing()
        {

            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Purchase_Order WHERE PurchaseOrderID='" + myID + "'", clsConnection.con);
            MySqlDataReader rs = cmd.ExecuteReader();
            while (rs.Read())
            {
                txtSupplier.Text = rs["Description"].ToString();
                txtPONo.Text = rs["PONo"].ToString();
                txtAddress.Text = rs["City_Town"].ToString() + ", " + rs["Province"].ToString() +  " " + rs["ZipCode"].ToString();
                txtDate.Text = rs["Date"].ToString();

                txtGrosse.Text = rs["Gross"].ToString();
                txtDiscount.Text = rs["Discount"].ToString();
                txtTaxBase.Text = rs["TaxBase"].ToString();
                txtVAT.Text = rs["Vat"].ToString();
                txtNet.Text = rs["NetAmount"].ToString();
                txtRemarks.Text = rs["Remarks"].ToString();

                cIGross = Convert.ToDecimal(txtGrosse.Text);
                cIAmount = Convert.ToDecimal(txtNet.Text);
                cDAmount = Convert.ToDecimal(txtDiscount.Text);
            }
            rs.Close();

            MySqlCommand com = new MySqlCommand("Select * From qry_Purchase_Order_Detail WHERE PurchaseOrderID=" + myID + "", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

            dtpInvoiceDate.Visible = true;
            txtInvoiceDate.Visible = false;
        }

        void DisplayForViewing()
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Purchase_Order_Receive WHERE InvoiceID=" + myID + "", clsConnection.con);
            MySqlDataReader rs = cmd.ExecuteReader();
            while (rs.Read())
            {
                txtSupplier.Text = rs["Description"].ToString();
                txtPONo.Text = rs["PONo"].ToString();
                txtAddress.Text = rs["Address"].ToString();
                txtDate.Text = rs["Date"].ToString();

                txtInvoiceNo.Text = rs["DeliveryNo"].ToString();

                txtGrosse.Text = rs["Gross"].ToString();
                txtDiscount.Text = rs["Discount"].ToString();
                txtTaxBase.Text = rs["TaxBase"].ToString();
                txtVAT.Text = rs["Vat"].ToString();
                txtNet.Text = rs["NetAmount"].ToString();

                cIGross = Convert.ToDecimal(txtGrosse.Text);
                cIAmount = Convert.ToDecimal(txtNet.Text);
                cDAmount = Convert.ToDecimal(txtDiscount.Text);
            }
            rs.Close();

            MySqlCommand com = new MySqlCommand("Select * From qry_Purchase_Order_Receiving_Detail WHERE InvoiceID='" + myID + "'", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

            dtpInvoiceDate.Visible = true;
            txtInvoiceDate.Visible = false;
            picPurchase.Visible = false;
            cmdSave.Visible = false;
            cmdAdd.Visible = false;

            CmdReturn.Left = cmdSave.Left;
            CmdReturn.Visible = true;
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (dgView.RowCount < 1)
            {
                MessageBox.Show("Please enter item to return before saving this record.");
            }

            else if (txtInvoiceNo.Text.Trim() == "")
            {
                MessageBox.Show("Please enter invoice number before saving this record.");
            }

            else if (txtDeliveryNo.Text.Trim() == "")
            {
                MessageBox.Show("Please enter delivery number before saving this record.");
            }

            else if (MessageBox.Show("This save the record. Do you want to proceed?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                SaveRecord();
            }
        }

        void SaveRecord()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string UnitType = string.Empty;
            string Qty = string.Empty;
            string netAmount = string.Empty;
            string Discount = string.Empty;

            string sSQL1 = "Insert Into Purchase_Order_Receive(InvoiceID,PurchaseOrderID,InvoiceNo,InvoiceDate,DeliveryNo,DeliveryDate,Agent,Shipper,Waybill,Terms,Remarks,Gross,Discount,TaxBase,Vat,NetAmount,CreatedOn,CreatedBy) " +
                           "Values('" + AutoID + "','" + myID + "','" + txtInvoiceNo.Text + "','" + dtpInvoiceDate.Value.ToShortDateString() + "','" + txtDeliveryNo.Text + "','" + dtpDeliveryDate.Value +
                            "','" + txtAgent.Text + "','" + txtShipper.Text + "','" + txtWaybill.Text + "','" + txtTerms.Text + "','" + txtRemarks.Text + "','" + txtGrosse.Text + "','" + txtDiscount.Text + "','" + txtTaxBase.Text + "','" + txtVAT.Text + "','" + txtNet.Text +
                            "','" + DateTime.Now.ToShortDateString() + "','" + clsFunctions.fullname + "')";

            MySqlCommand com = new MySqlCommand(sSQL1, clsConnection.con);
            com.ExecuteNonQuery();

            for (int n = 0; n < dgView.RowCount; n++)
            {
                ItemNo = dgView.Rows[n].Cells[0].Value.ToString();
                Description = dgView.Rows[n].Cells[1].Value.ToString();
                Qty = dgView.Rows[n].Cells[2].Value.ToString();
                UnitPrice = dgView.Rows[n].Cells[3].Value.ToString();
                Discount = dgView.Rows[n].Cells[5].Value.ToString();
                netAmount = dgView.Rows[n].Cells[6].Value.ToString();

                string sSQL2 = "Insert Into Purchase_Order_Receiving_Detail(InvoiceID,products_id,Qty,Price,Discount) Values ('" + AutoID +
                                "','" + ItemNo + "','" + Qty + "','" + UnitPrice + "','" + Discount + "')";
                MySqlCommand cmd = new MySqlCommand(sSQL2, clsConnection.con);
                cmd.ExecuteNonQuery();

                string sSQL3 = "Update Purchase_Order_Detail set QtyReceived = QtyReceived + " + Qty + " where products_id='" + ItemNo + "'";
                MySqlCommand up = new MySqlCommand(sSQL3, clsConnection.con);
                up.ExecuteNonQuery();


                string sSQL4 = "Update stockinv set EndingInv = EndingInv + " + Qty + " where products_id='" + ItemNo + "'";
                MySqlCommand pipo = new MySqlCommand(sSQL4, clsConnection.con);
                pipo.ExecuteNonQuery();

            }

            MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + AutoID + "' where TableName ='" + "Purchase_Order_Receive" + "'", clsConnection.con);
            pipz.ExecuteNonQuery();

            if (mFormState == "ADD")
            {
                MessageBox.Show("New record has been successfully saved.");
                this.Close();
            }
        }

        private void txtQty_TextChanged(object sender, EventArgs e)
        {
            decimal Total;
            decimal sum = 0;

            if (txtQty.Text.Equals("") || txtDisc.Text.Equals(""))
            {
                txtNetAmount.Text = "0.00";
            }
            else
            {
                int quantity = int.Parse(txtQty.Text);
                decimal unitprice = decimal.Parse(txtUnitPrice.Text);
                decimal discount = decimal.Parse(txtDisc.Text);


                Total = decimal.Parse(txtUnitPrice.Text) * decimal.Parse(txtQty.Text);
                txtGross.Text = String.Format("{0:0.##}", Total);

                sum = Convert.ToDecimal(Total - ((discount / 100) * Total));
                txtNetAmount.Text = sum.ToString();
            }

        }

        private void CmdReturn_Click(object sender, EventArgs e)
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Purchase_Order_Receiving_Detail WHERE InvoiceID=" + myID + " AND QtyDue > 0 ORDER BY products_id ASC", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                frmPurchaseOrderReturnAE returns = new frmPurchaseOrderReturnAE();
                returns.mFormState = "ADD";
                returns.myID = myID;
                returns.ShowDialog();
            }
            else
            {
                MessageBox.Show("All items are already received.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                dr.Close();
            }
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {

        }

        void CalculateTotalPrice()
        {
            //Initial Amount
            decimal tGross = 0;
            decimal tNet = 0;
            decimal tAX = 0;
            decimal tVat = 0;
            //Quantity
            int Quan = 0;
            int Quant = 0;
            int Quanti = 0;
            //Discount
            decimal cDAmount = 0;
            decimal price = 0;

            int i = dgView.RowCount;

            for (int a = 0; a < i; a++)
            {
                try
                {
                    //Initial Total of items in list
                    tGross += decimal.Parse(dgView.Rows[a].Cells[4].Value.ToString());
                    tNet += decimal.Parse(dgView.Rows[a].Cells[6].Value.ToString());
                    //Total Quantity of items in list
                    Quan += int.Parse(dgView.Rows[a].Cells[2].Value.ToString());
                    //Total Price
                    price += decimal.Parse(dgView.Rows[a].Cells[3].Value.ToString());
                    //Total Discount of items in list
                    cDAmount = cDAmount + Convert.ToDecimal((Convert.ToDecimal(dgView.Rows[a].Cells[5].Value.ToString()) / 100) * (Convert.ToDecimal(Quan) * Convert.ToDecimal(price)));
                }
                catch (Exception)
                {
                }
            }
            Quanti = Quant + Quan;
            tAX = (tNet / 1.12m);
            tVat = tNet - Convert.ToDecimal(tAX);

            //txtDiscount.Text = cDAmount.ToString();

            txtGrosse.Text = String.Format("{0:0.00}", tGross);
            txtNet.Text = String.Format("{0:0.00}", tNet);
            txtTaxBase.Text = String.Format("{0:0.00}", tAX);
            txtVAT.Text = String.Format("{0:0.00}", tVat);
        }

        private void cmdPrintPreview_Click(object sender, EventArgs e)
        {
            frmPrintPreview report = new frmPrintPreview();
            report.WindowState = FormWindowState.Maximized;
            report.strReport = "Receiving Report";
            report.strWhere = "{Purchase_Order_Receive.InvoiceID} =" + myID;
            report.Show();
        }

        private void dgView_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            int n = dgView.CurrentRow.Index;
            
            txtStockNo.Text = dgView.Rows[n].Cells[0].Value.ToString();
            txtStock.Text = dgView.Rows[n].Cells[1].Value.ToString();
            txtQty.Text = dgView.Rows[n].Cells[2].Value.ToString();
            txtUnitPrice.Text = dgView.Rows[n].Cells[3].Value.ToString();
            txtGross.Text = dgView.Rows[n].Cells[4].Value.ToString();
            txtDisc.Text = dgView.Rows[n].Cells[5].Value.ToString();
            txtNetAmount.Text = dgView.Rows[n].Cells[6].Value.ToString();
        }

        private void txtStock_KeyDown(object sender, KeyEventArgs e)
        {
            txtQty.Text = "1";
            txtDisc.Text = "0";
            txtQty_TextChanged(this, new System.EventArgs());
        }

    }
}