﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
 
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;
using Microsoft.Office.Interop.Excel;

namespace StockandInventory_Module
{
    public partial class frmSalesOrder : Form
    {
        public frmSalesOrder()
        {
            InitializeComponent();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            frmSalesOrderAE SalesOrder = new frmSalesOrderAE();
            SalesOrder.mFormState = "ADD";
            SalesOrder.ShowDialog();
        }

        private void frmSalesOrder_Load(object sender, EventArgs e)
        {
            try
            {
                if (clsConnection.con.State == ConnectionState.Open)
                { clsConnection.con.Close(); }
                clsConnection.con.Open();
                FillListView();
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        void FillListView()
        {
            MySqlCommand com = new MySqlCommand("Select SONo, Fullname, Date, Salesman, QtyOrdered, QtyRcvd, QtyDue, SalesOrderID From qry_Sales_Order Order By Date DESC", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            listView1.Items.Clear();
            while (dr.Read())
            {
                ListViewItem lv = new ListViewItem(dr["SONo"].ToString());
                lv.SubItems.Add(dr["Fullname"].ToString());
                lv.SubItems.Add(dr["Date"].ToString());
                lv.SubItems.Add(dr["Salesman"].ToString());
                lv.SubItems.Add(dr["QtyOrdered"].ToString());
                lv.SubItems.Add(dr["QtyRcvd"].ToString());
                lv.SubItems.Add(dr["QtyDue"].ToString());
                lv.SubItems.Add(dr["SalesOrderID"].ToString());
                listView1.Items.AddRange(new ListViewItem[] { lv });
                lv.ImageIndex = 0;
            }
            dr.Close();
        }

        public void ModifySalesOrder()
        {

            frmSalesOrderAE frm = new frmSalesOrderAE();
            frm.mFormState = "EDIT";
            frm.myID = Convert.ToInt32(listView1.Items[listView1.FocusedItem.Index].SubItems[7].Text);
            frm.ShowDialog();
        }

        private void cmdRefresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        private void frmSalesOrder_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            { this.Close(); }
        }

        private void cmdEdit_Click(object sender, EventArgs e)
        {
            ModifySalesOrder();
        }

        private void cmdDelete_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Are you sure you want to void the selected record?\n\n WARNING: You cannot undo this operation.This will permanently remove the record.", "Confirm Record", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                MySqlCommand command = new MySqlCommand("DELETE FROM Sales_Order WHERE SalesOrderID ='" + listView1.FocusedItem.Text + "'", clsConnection.con);
                command.ExecuteNonQuery();

                MessageBox.Show("Record has been successfully removed.");
            }
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            ModifySalesOrder();
        }

        private void cmdExcel_Click(object sender, EventArgs e)
        {
            Microsoft.Office.Interop.Excel.Application xla = new Microsoft.Office.Interop.Excel.Application();
            xla.Visible = true;
            Workbook wb = xla.Workbooks.Add(XlSheetType.xlWorksheet);
            Worksheet ws = (Worksheet)xla.ActiveSheet;
            int i = 1;
            int j = 1;
            foreach (ListViewItem comp in listView1.Items)
            {
                ws.Cells[i, j] = comp.Text.ToString();
                //MessageBox.Show(comp.Text.ToString());
                foreach (ListViewItem.ListViewSubItem drv in comp.SubItems)
                {
                    ws.Cells[i, j] = drv.Text.ToString();
                    j++;
                }
                j = 1;
                i++;
            }

        }

        private void btn_close_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}