﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
 
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmSalesOrderAE : Form
    {
        public string mFormState;
        public int myID;

        public frmSalesOrderAE()
        {
            InitializeComponent();
        }

        private void frmSalesOrderAE_Load(object sender, EventArgs e)
        {
            try
            {
                if (clsConnection.con.State == ConnectionState.Open)
                { clsConnection.con.Close(); }
                clsConnection.con.Open();

                switch (mFormState)
                {
                    case "ADD":
                        ItemAutoComplete();
                        AutoCompleteCustomer();
                        GenerateSalesOrder();

                        cmdPrintPreview.Visible = false;
                        dtpDate.Value = DateTime.Now;
                        this.Text = "Create New Entry";
                        cmdModificationHistory.Enabled = false;
                        break;

                    case "EDIT":
                        ItemAutoComplete();
                        AutoCompleteCustomer();

                        DisplayForViewing();

                        picPurchase.Visible = false;
                        cmdPrintPreview.Visible = true;
                        cmdCancel.Text = "Close";
                        cmdModificationHistory.Enabled = true;

                        break;
                }
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        void DisplayForViewing()
        {
            MySqlCommand com = new MySqlCommand();
            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader read;
            MySqlDataReader dr;

            com.CommandText = "Select * from qry_sales_order where SalesOrderID='" + myID + "'";
            com.Connection = clsConnection.con;
            read = com.ExecuteReader();
            while (read.Read())
            {
                
                txtSONo.Text = read["SONo"].ToString();
                txtSoldTo.Text = read["Fullname"].ToString();
                txtCustomerID.Text = read["customers_id"].ToString();
                txtDate.Text = read["Date"].ToString();
                txtSalesman.Text = read["Salesman"].ToString();
                txtAddress.Text = read["PermanentAddress"].ToString();
                txtOrderedBy.Text = read["OrderedBy"].ToString();
                txtDispatched.Text = read["DispatchedBy"].ToString();
                txtInstructions.Text = read["DeliveryInstructions"].ToString();
                txtGrosse.Text = read["Gross"].ToString();
                txtDiscount.Text = read["Discount"].ToString();
                txtTaxBase.Text = read["TaxBase"].ToString();
                txtVAT.Text = read["Vat"].ToString();
                txtNet.Text = read["NetAmount"].ToString();
                txtRemarks.Text = read["Remarks"].ToString();
            }
            read.Close();

            cmd.CommandText = "Select * From qry_Sales_Order_Detail where SalesOrderID='" + myID + "'";
            cmd.Connection = clsConnection.con;
            dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                int n = dgView.Rows.Add();
                dgView.Rows[n].Cells[0].Value = dr["products_id"].ToString();
                dgView.Rows[n].Cells[1].Value = dr["products_Title"].ToString();
                dgView.Rows[n].Cells[2].Value = dr["Qty"].ToString();
                dgView.Rows[n].Cells[3].Value = Convert.ToDecimal(dr["Price"].ToString());
                dgView.Rows[n].Cells[4].Value = Convert.ToDecimal(dr["Gross"].ToString());
                dgView.Rows[n].Cells[5].Value = Convert.ToInt32(dr["Discount"].ToString()) * 100;
                dgView.Rows[n].Cells[6].Value = Convert.ToDecimal(dr["NetAmount"].ToString());
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;
            }
            dr.Close();

            dtpDate.Visible = false;
            txtDate.Visible = true;
            cmdSave.Visible = true;
            cmdAdd.Visible = true;
            CmdReceiveItem.Left = cmdSave.Left;
            CmdReceiveItem.Visible = true;
        }

        private void GenerateSalesOrder()
        {
            MySqlCommand cmddr = new MySqlCommand("select NextNo from Generator where TableName='" + "Sales_Order" + "'", clsConnection.con);
            MySqlDataReader dr = cmddr.ExecuteReader();
            while (dr.Read())
            {
                string strid = (dr["NextNo"].ToString());
                if (strid == "")
                {
                    txtSONo.Text = "SO-" + "1";
                    myID = 1;
                }
                else
                {
                    myID = Convert.ToInt32(dr["NextNo"]) + 1;
                    txtSONo.Text = "SO-" + myID.ToString();
                }
            }
            dr.Close();
        }

        void ItemAutoComplete()
        {
            MySqlCommand com = new MySqlCommand("Select products_Title,products_id From products", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtStock.AutoCompleteCustomSource.Add(dr["products_Title"].ToString());
            }
            dr.Close();
        }

        void AutoCompleteCustomer()
        {
            MySqlCommand com = new MySqlCommand("Select Fullname, customers_id From qrycustomers_detail", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtSoldTo.AutoCompleteCustomSource.Add(dr["Fullname"].ToString());
            }
            dr.Close();
        }

        void CustomerIDNo(string sID)
        {
            MySqlCommand com = new MySqlCommand("Select * From qrycustomers_detail where Fullname Like '%" + sID + "%'", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            while (dr.Read())
            {
                txtCustomerID.Text = dr["customers_id"].ToString();
                txtAddress.Text = dr["PermanentAddress"].ToString();
            }
            dr.Close();
        }

        void SearchItem(string ItemNo)
        {
            decimal UnitPrice;

            MySqlCommand cmd = new MySqlCommand();
            MySqlDataReader dr;

            cmd.CommandText = "Select * From products where products_Title Like '%" + ItemNo.Trim() + "%'";
            cmd.Connection = clsConnection.con;
            cmd.CommandType = CommandType.Text;
            dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                txtStockNo.Text = (String)dr["products_id"].ToString();
                txtStock.Text = (String)dr["products_Title"].ToString();
                UnitPrice = Convert.ToDecimal(dr["SellingPrice"].ToString());
                txtUnitPrice.Text = String.Format("{0:0.##}", UnitPrice);
            }
            dr.Close();
        }


        void Clear()
        {
            txtStockNo.Text = "";
            txtStock.Text = "";
            txtQty.Text = "1";
            txtUnitPrice.Text = "";
            txtGross.Text = "";
            txtDisc.Text = "0";
            txtNetAmount.Text = "";
        }

        private void txtStock_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                SearchItem(txtStock.Text);
                txtDisc.Text = "0";
                txtQty.Text = "0";
                txtQty_TextChanged(this, new System.EventArgs());
            }
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            if (txtStock.Text == "")
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.");
            }
            else
            {
                for (int row = 0; row < dgView.Rows.Count; row++)
                {
                    for (int col = 0; col < dgView.Columns.Count; col++)
                    {
                        if (dgView.Rows[row].Cells[col].Value != null &&
                          dgView.Rows[row].Cells[col].Value.Equals(txtStock.Text))
                        {
                            MessageBox.Show("Item Already Exist...");
                            return;
                        }
                    }
                }
                int n = dgView.Rows.Add();
                //int intQtyOrdered = int.Parse(txtQty.Text);

                dgView.Rows[n].Cells[0].Value = txtStockNo.Text;
                dgView.Rows[n].Cells[1].Value = txtStock.Text;
                dgView.Rows[n].Cells[2].Value = txtQty.Text;
                dgView.Rows[n].Cells[3].Value = txtUnitPrice.Text;
                dgView.Rows[n].Cells[4].Value = txtGross.Text;
                dgView.Rows[n].Cells[5].Value = txtDisc.Text;
                dgView.Rows[n].Cells[6].Value = txtNetAmount.Text;
                dgView.FirstDisplayedScrollingRowIndex = n;
                dgView.CurrentCell = dgView.Rows[n].Cells[0];
                dgView.Rows[n].Selected = true;

                Clear();
                CalculateTotalPrice();
            }
        }

        void CalculateTotalPrice()
        {
            //Initial Amount
            decimal tGross = 0;
            decimal tNet = 0;
            decimal tAX = 0;
            decimal tVat = 0;
            //Quantity
            int Quan = 0;
            int Quant = 0;
            int Quanti = 0;
            //Discount
            decimal cDAmount = 0;
            decimal price = 0;

            int i = dgView.RowCount;

            for (int a = 0; a < i; a++)
            {
                try
                {
                    //Initial Total of items in list
                    tGross += decimal.Parse(dgView.Rows[a].Cells[4].Value.ToString());
                    tNet += decimal.Parse(dgView.Rows[a].Cells[6].Value.ToString());
                    //Total Quantity of items in list
                    Quan += int.Parse(dgView.Rows[a].Cells[2].Value.ToString());
                    //Total Price
                    price += decimal.Parse(dgView.Rows[a].Cells[3].Value.ToString());
                    //Total Discount of items in list
                    cDAmount = cDAmount + Convert.ToDecimal((Convert.ToDecimal(dgView.Rows[a].Cells[5].Value.ToString()) / 100) * (Convert.ToDecimal(Quan) * Convert.ToDecimal(price)));
                }
                catch (Exception)
                {
                }
            }
            Quanti = Quant + Quan;
            tAX = (tNet / 1.12m);
            tVat = tNet - Convert.ToDecimal(tAX);

            //txtDiscount.Text = cDAmount.ToString();

            txtGrosse.Text = String.Format("{0:0.00}", tGross);
            txtNet.Text = String.Format("{0:0.00}", tNet);
            txtTaxBase.Text = String.Format("{0:0.00}", tAX);
            txtVAT.Text = String.Format("{0:0.00}", tVat);
        }

        private void txtSoldTo_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                CustomerIDNo(txtSoldTo.Text);
            }
        }

        private void txtQty_TextChanged(object sender, EventArgs e)
        {
            decimal Total;
            decimal sum = 0;

            if (txtQty.Text.Equals("") || txtDisc.Text.Equals(""))
            {
                txtNetAmount.Text = "0.00";
            }
            else
            {
                int quantity = int.Parse(txtQty.Text);
                decimal unitprice = decimal.Parse(txtUnitPrice.Text);
                decimal discount = decimal.Parse(txtDisc.Text);


                Total = decimal.Parse(txtUnitPrice.Text) * decimal.Parse(txtQty.Text);
                txtGross.Text = String.Format("{0:0.##}", Total);

                sum = Convert.ToDecimal(Total - ((discount / 100) * Total));
                txtNetAmount.Text = sum.ToString();

            }
        }

        private void cmdSave_Click(object sender, EventArgs e)
        {
            if (dgView.RowCount < 1)
            {
                MessageBox.Show("Please enter item to purchase before you can save this record.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtStock.Focus();
            }

            if (txtSoldTo.Text == "")
            {
                MessageBox.Show("Please select a client.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtSoldTo.Focus();
            }

            if (MessageBox.Show("This save the record. Do you want to proceed?", "Front Desk Module", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                SaveSalesOrder();
            }
        }

        void SaveSalesOrder()
        {
            string ItemNo = string.Empty;
            string Description = string.Empty;
            string UnitPrice = string.Empty;
            string UnitType = string.Empty;
            string Qty = string.Empty;
            string netAmount = string.Empty;
            string Discount = string.Empty;

            MySqlCommand Sales_Order = new MySqlCommand();
            MySqlCommand Sales_Order_Details = new MySqlCommand();

            Sales_Order.CommandText = "Insert Into sales_order(SalesOrderID,CreatedBy,CreatedOn,customers_id,SONo,Date,Salesman,OrderedBy,DispatchedBy,DeliveryInstructions,Gross,Discount,TaxBase,Vat,NetAmount,Remarks) " +
                              "Values ('" + myID + "','" + clsFunctions.fullname + "','" + DateTime.Now.Date.ToShortDateString() + "','" + txtCustomerID.Text + "','" + txtSONo.Text + "','" + dtpDate.Value.ToShortDateString() + "','" + txtSalesman.Text +
                              "','" + txtOrderedBy.Text + "','" + txtDispatched.Text + "','" + txtInstructions.Text + "','" + txtGrosse.Text + "','" + txtDiscount.Text + "','" + txtTaxBase.Text + "','" + txtVAT.Text + "','" + txtNet.Text + "','" + txtRemarks.Text + "')";
            Sales_Order.Connection = clsConnection.con;
            Sales_Order.ExecuteNonQuery();


            for (int n = 0; n < dgView.RowCount; n++)
            {
                ItemNo = dgView.Rows[n].Cells[0].Value.ToString();
                Description = dgView.Rows[n].Cells[1].Value.ToString();
                Qty = dgView.Rows[n].Cells[2].Value.ToString();
                UnitPrice = dgView.Rows[n].Cells[3].Value.ToString();
                Discount = dgView.Rows[n].Cells[5].Value.ToString();
                netAmount = dgView.Rows[n].Cells[6].Value.ToString();

                Sales_Order_Details.CommandText = "Insert Into sales_order_details(SalesOrderID,products_id,Qty,Price,Discount,CreatedBy,CreatedOn) " +
                                                    "Values('" + myID + "','" + ItemNo + "','" + Qty + "','" + UnitPrice + "','" + Discount + "','" + clsFunctions.fullname + "','" + DateTime.Now.ToShortDateString() + "')";
                Sales_Order_Details.Connection = clsConnection.con;
                Sales_Order_Details.ExecuteNonQuery();

            }

            MySqlCommand pipz = new MySqlCommand("Update Generator Set NextNo='" + myID + "' where TableName ='" + "Sales_Order" + "'", clsConnection.con);
            pipz.ExecuteNonQuery();


            MessageBox.Show("New record has been successfully saved.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
            this.Close();
        }

        private void cmdPrintPreview_Click(object sender, EventArgs e)
        {

        }

        private void cmdCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void CmdReceiveItem_Click(object sender, EventArgs e)
        {
            MySqlCommand cmd = new MySqlCommand("SELECT * FROM qry_Sales_Order_Detail WHERE SalesOrderID='" + myID + "' AND QtyDue > 0 ORDER BY products_id ASC", clsConnection.con);
            MySqlDataReader dr = cmd.ExecuteReader();
            dr.Read();
            if (dr.HasRows)
            {
                frmSalesOrderDeliveryAE deliver = new frmSalesOrderDeliveryAE();
                deliver.mFormState = "ADD";
                deliver.myID = myID;
                deliver.ShowDialog();
            }
            else
            {
                MessageBox.Show("All items are already received.", "Front Desk Module", MessageBoxButtons.OK, MessageBoxIcon.Information);
                dr.Close();
            }
        }

        private void dgView_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            {
                if (dgView.SelectedRows.Count > 0)
                {
                    dgView.Rows.RemoveAt(dgView.SelectedRows[0].Index);
                    CalculateTotalPrice();
                }
                else
                {
                    MessageBox.Show("Select one item to remove!");
                }
            }
        }

        private void dgView_CellClick(object sender, DataGridViewCellEventArgs e)
        {

        }

   }
}
