﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
 
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace StockandInventory_Module
{
    public partial class frmSalesOrderReturn : Form
    {
        public frmSalesOrderReturn()
        {
            InitializeComponent();
        }

        private void cmdAdd_Click(object sender, EventArgs e)
        {
            frmSalesOrderReturnAE returnae = new frmSalesOrderReturnAE();
            returnae.mFormState = "ADD";
            returnae.Show();
        }

        private void cmdEdit_Click(object sender, EventArgs e)
        {
            frmSalesOrderReturnAE salesreturn = new frmSalesOrderReturnAE();
            salesreturn.mFormState = "EDIT";
            salesreturn.myID = Convert.ToInt32(listView1.Items[listView1.FocusedItem.Index].SubItems[5].Text);
            salesreturn.ShowDialog();
        }

        private void cmdRefresh_Click(object sender, EventArgs e)
        {
            FillListView();
        }

        private void frmSalesOrderReturn_Load(object sender, EventArgs e)
        {
            try
            {
                if (clsConnection.con.State == ConnectionState.Open)
                { clsConnection.con.Close(); }
                clsConnection.con.Open();
                FillListView();
            }
            catch (MySqlException ex)
            {
                MessageBox.Show(ex.Message, "Database Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        void FillListView()
        {
            MySqlCommand com = new MySqlCommand("Select SONo, Fullname, DeliveryNo, DeliveryDate, QtyReturned, SalesOrderReturnID From qry_sales_order_return Order By DeliveryDate DESC", clsConnection.con);
            MySqlDataReader dr = com.ExecuteReader();
            listView1.Items.Clear();
            while (dr.Read())
            {
                ListViewItem lv = new ListViewItem(dr["SONo"].ToString());
                lv.SubItems.Add(dr["Fullname"].ToString());
                lv.SubItems.Add(dr["DeliveryNo"].ToString());
                lv.SubItems.Add(dr["DeliveryDate"].ToString());
                lv.SubItems.Add(dr["QtyReturned"].ToString());
                lv.SubItems.Add(dr["SalesOrderReturnID"].ToString());
                listView1.Items.AddRange(new ListViewItem[] { lv });
                lv.ImageIndex = 0;
            }
            dr.Close();
        }

        private void btn_close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}
